<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Newsletter"				                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

=== Version 4.3e / January 2014 ===

*/

if (!defined('CPO')) exit;

// Modulaktionen

include_once(CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/newsletter_functions.inc.php');
$translator->addTranslation('frontend',CPO_BASEDIR.$activeModules[$directory]['directory'].'/lang');

// action-Anweisungen
switch($_GET['action'])  {
	case 'delete':
		newsletter_receiver_delete((int)$_GET['nr'],addslashes($_GET['hash']));
		if ($activeModules[$directory]['log'] == 'yes') logaction('Newsletter recipient deleted', '');
		break;
	case 'unscribe':
		newsletter_receiver_unscribe(addslashes($_GET['hash']));
		if ($activeModules[$directory]['log'] == 'yes') logaction('Newsletter recipient unscribed', '');
		$message[] = $activeModules[$directory]['unscribe_info'];
		break;
	case 'activate':
		newsletter_receiver_activate((int)$_GET['nr'],addslashes($_GET['hash']));
		if ($activeModules[$directory]['log'] == 'yes') logaction('Newsletter recipient activated', '');
		break;
	case 'deactivate':
		newsletter_receiver_deactivate((int)$_GET['nr'],addslashes($_GET['hash']));
		if ($activeModules[$directory]['log'] == 'yes') logaction('Newsletter recipient deactivated', '');
		break;
	case 'ban':
		newsletter_receiver_ban((int)$_GET['nr'],addslashes($_GET['hash']));
		if ($activeModules[$directory]['log'] == 'yes') logaction('Newsletter recipient banned', '');
		break;
}

switch($_GET['rank'])  {
	case 'up':
		newsletter_receiver_up((int)$_GET['nr']);
		if ($activeModules[$directory]['log'] == 'yes') logaction('Newsletter recipient rank up', '');
		break;
	case 'down':
		newsletter_receiver_down((int)$_GET['nr']);
		if ($activeModules[$directory]['log'] == 'yes') logaction('Newsletter recipient rank down', '');
		break;
}


// Empfngereinstellungen speichern
if (isset($_POST['receiver']) && !is_email_valid($_POST['receiver_email']))  {
	$message[] = __('Invalid email-adress. Please try again!');
	$_GET['action'] = 'modify';
	$_POST['list'] = '';
	$_GET['nr'] = $_POST['id'];
} elseif (isset($_POST['receiver']) && $_POST['receiver'] == "create" && check_receiver($_POST['receiver_email']) == 1)  {
	$message[] = sprintf($activeModules[$directory]['hint_already_in_list'], $_POST['receiver_email']);
	$_GET['action'] = 'modify';
	$_POST['list'] = '';
	$_GET['nr'] = $_POST['id'];
} elseif (isset($_POST['receiver']) && $_POST['receiver'] == "create" && check_receiver($_POST['receiver_email']) == 2)  {
	$message[] = sprintf($activeModules[$directory]['hint_banned'], $_POST['receiver_email']);
	//$_GET['action'] = 'modify';
	//$_POST['list'] = '';
	//$_GET['nr'] = $_POST['id'];
    return;
} elseif (isset($_POST['receiver']) && is_email_valid($_POST['receiver_email']))  {
	$now        = time();
	$email_md5  = md5($_POST['receiver_email'].time());
	
	if ($_POST['receiver'] == "modify") {   // modifizieren
		$all_necessary = true;
		if (isset($_POST['personal_necessary']))  {
			foreach($_POST['personal_necessary'] AS $check)  {
				if (!isset($_POST['receiver_personal'][$check]) || $_POST['receiver_personal'][$check] == '')  {
					$message[] = sprintf($activeModules[$directory]['necessary_data'],$check);
					$all_necessary = false;
				}
			}
		}
		if (isset($_POST['receiver_personal']))  {
			$data_personalize = ", personalize = '".serialize($_POST['receiver_personal'])."'";
		} else {
			$data_personalize = ", personalize = NULL";
		}
		if ($all_necessary == false) {
			$_GET['action'] = 'modify';
			$_POST['list'] = '';
			$_GET['nr'] = $_POST['id'];
			return;
		}
		if ($_POST['receiver_password'] != '')  $alter_password = ", password = '".md5($_POST['receiver_password'])."'";
		$query = "UPDATE ".$dbPrefix."_mod_newsletter_adresses SET name = '".addslashes($_POST['receiver_name'])."', email = '".addslashes($_POST['receiver_email'])."', rank = '".(int)$_POST['receiver_rank']."', categories = '".addslashes($_POST['receiver_categories'])."'"
		.$data_personalize
		.$alter_password." WHERE id ='".(int)$_POST['id']."'";
		DEBUG(1, $query, __FILE__, __LINE__);
		$db_r = new DB;
		$db_r->query($query); 
		if ($activeModules[$directory]['log'] == 'yes') logaction('Newsletter recipient added', addslashes($_POST['receiver_email']));
		$message[] = __('Recipient data was saved!');
	} elseif ($_POST['receiver'] == "create" && check_receiver(addslashes($_POST['receiver_email'])) === FALSE) {  // neu anlegen
		$all_necessary = true;
		if (isset($_POST['personal_necessary']))  {
			foreach($_POST['personal_necessary'] AS $check)  {
				if (!isset($_POST['receiver_personal'][$check]) || $_POST['receiver_personal'][$check] == '')  {
					$message[] = sprintf(__('You need to fill in a value for <b>%s</b>!'),$check);
					$all_necessary = false;
				}
			}
		}
		if (isset($_POST['receiver_personal']))  {
			$data_personalize = ", '".serialize($_POST['receiver_personal'])."'";
		} else {
			$data_personalize = ", NULL";
		}
		if ($all_necessary == false) {
			$_GET['action'] = 'modify';
			$_POST['list'] = '';
			$_GET['nr'] = $_POST['id'];
			return;
		}
		if ($_POST['receiver_password'] != '')  $password = md5($_POST['receiver_password']);
		$query = "INSERT INTO ".$dbPrefix."_mod_newsletter_adresses (newsletter, name, email, rank, categories, password, hash, time, ctime, active, personalize) VALUES ('".$directory."','".addslashes($_POST['receiver_name'])."', '".addslashes($_POST['receiver_email'])."', '".(int)$_POST['receiver_rank']."', '".addslashes($_POST['receiver_categories'])."', '".$password."', '".$email_md5."', '0000-00-00 00:00:00', '".$now."', 1".$data_personalize.")";
		DEBUG(1, $query, __FILE__, __LINE__);
		$db_r = new DB;
		$db_r->query($query); 
		if ($activeModules[$directory]['log'] == 'yes') logaction('Newsletter recipient added', addslashes($_POST['receiver_email']));
		$message[] = __('Recipient data was saved!');
	} else {
		$message[] = __('Error while saving recipient data!');
	}
}

// Empfngerupload
if ($_POST['upload'] == 1) {
	$c_datum = date ( "Y-m-d H:m:i" ,time() );
	$updates = 0;
	$inserts = 0;
	$email_md5 = '';
	for ($r=0;$r<count($empfaenger);$r++)  {
		$email_md5  = md5($empfaenger[$r].time());
		$query = "SELECT * FROM ".$dbPrefix."_mod_newsletter_adresses WHERE email = '".$empfaenger[$r]."' AND newsletter='".$directory."'";
		DEBUG(1, $query, __FILE__, __LINE__); 
		$db = new DB;
		$db->query($query);
		if ( $db->num_rows()>0 )  {
			$query = "UPDATE ".$dbPrefix."_mod_newsletter_adresses SET name='".$empfaenger_info[$r]."', email='".$empfaenger[$r]."' WHERE email = '".$empfaenger[$r]."'";
			DEBUG(1, $query, __FILE__, __LINE__); 
			$db = new DB;
			$db->query($query);
			$updates++;
		} else {
			$query = "INSERT INTO ".$dbPrefix."_mod_newsletter_adresses (newsletter, name, email, rank, categories, time, active, hash) VALUES ('".$directory."', '".$empfaenger_info[$r]."', '".$empfaenger[$r]."', '".$activeModules[$directory]['default_rank']."', 'all', '".$c_datum."', '1', '".$email_md5."')";
			DEBUG(1, $query, __FILE__, __LINE__); 
			$db = new DB;
			$db->query($query);
			$inserts++;
		}
	}

	if ($activeModules[$directory]['log'] == 'yes') logaction('Newsletter recipient list uploaded', $updates.' updated / '.$inserts.' added');
	$message[] = __('Recipient list was imported into database!');
	$message[] = $updates.__(' records were updated');
	$message[] = $inserts.__(' records were added');
}

// Rechteeinstellungen speichern
if(isset($_GET['newsletter_user_id'])) {
	$newsletter_user_id = $_GET['newsletter_user_id'];
	$newsletter_set_rights = $_GET['set'];
	$_POST['go'] = true;
	$activeModules[$directory]['rights'][$newsletter_user_id]=$newsletter_set_rights;
}

// Moduleinstellungen speichern (neue Version mit automatischem Einlesen neuer Variablen) ************************
if (isset($_POST['go'])) {
	$new_settings = ($_POST) ? $_POST : $_GET ;
    foreach ($activeModules[$directory] as $k=>$v) {
        if (!isset($_POST['cpoNewsletterNew'][$k])) continue;
        if (is_bool($activeModules[$directory][$k])) {
            $activeModules[$directory][$k] = (bool) $_POST['cpoNewsletterNew'][$k];
        } else  {
			$activeModules[$directory][$k] = $_POST['cpoNewsletterNew'][$k];
		}
		if (array_key_exists($k, $new_settings['cpoNewsletterNew'])) unset($new_settings['cpoNewsletterNew'][$k]);
    }
	if (isset($new_settings['cpoNewsletterNew']))  {
		foreach ($new_settings['cpoNewsletterNew'] as $k=>$v) {
			$activeModules[$directory][$k] = $new_settings['cpoNewsletterNew'][$k];
		}
	}
    $c_datum = date ("Y-m-d H:i:s", time());
    $query = sprintf(
             "UPDATE ".CPO_MODULES." SET options ="
            ." '%s' WHERE name = '".$directory."'", 
            addslashes(serialize($activeModules[$directory]))
    );
    DEBUG(1, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query); 

	// automatisches Template erstellen
	$auto_template = "<!--\n*************************************************************\nDieses Template wird automatisch generiert. nderungen haben keinen Effekt auf die Ausgabe des Newsletters und werden berschrieben!\nThis template is auto generated. Changes will have no effect on the newsletter and will be overwritten!\n*************************************************************\n-->\n";
	if ($activeModules[$directory]['use_categories'] == 'yes')  {
		$categories = explode(";",$activeModules[$directory]['header'].";".$activeModules[$directory]['categories'].";".$activeModules[$directory]['footer']);
	} elseif ($activeModules[$directory]['use_categories'] == 'no')  {
		$categories = explode(";",$activeModules[$directory]['header'].";".$activeModules[$directory]['main'].";".$activeModules[$directory]['footer']);
	}
	for ($c=0;$c<count($categories);$c++)  {
		if ($activeModules[$directory]['text_only'] == 'no')  {
			$auto_template .= '<!-- HTML: '.$categories[$c].'; --><!-- HTML: '.$categories[$c].'; strip_tags; -->';
		}  elseif ($activeModules[$directory]['text_only'] == 'yes')  {
			$auto_template .= '<!-- Text: '.$categories[$c].'; -->';
		}  elseif ($activeModules[$directory]['text_only'] == 'both')  {
			$auto_template .= '<!-- HTML: '.$categories[$c].'; --><!-- Text: '.$categories[$c].'; -->';
		}
	}
	$query = "UPDATE ".CPO_TEMPLATES." SET tpl_detail = '".$auto_template."' WHERE name = '".$activeModules[$directory]['newsletter_template']."'";
    DEBUG(1, $query, __FILE__, __LINE__);
    $db_c = new DB;
    $db_c->query($query); 
	// insert into placeholder-table
	$query = "SELECT id FROM ".CPO_TEMPLATES." WHERE name ='".$activeModules[$directory]['newsletter_template']."'";
    DEBUG(1, $query, __FILE__, __LINE__);
    $db_c = new DB;
    $db_c->query($query); 
	$db_c->next_record();
	$mod_template_id = $db_c->v('id');
	$query = "DELETE FROM ".CPO_PLACEHOLDERS." WHERE templates_id ='".$mod_template_id."'";
    DEBUG(1, $query, __FILE__, __LINE__);
    $db_c = new DB;
    $db_c->query($query);
	$n = 1;
	if ($activeModules[$directory]['text_only'] == 'no') {
		$HTML_label = __('This content will be used in the HTML part of the newsletter. For editing click on the edit-link below.<br />It will be automatically used as plain-text content by removing all HTML-tags.');
	} else {
		$HTML_label = __('This content will be used in the HTML part of the newsletter. For editing click on the edit-link below.');
	}
	if ($activeModules[$directory]['text_only'] == 'both') $HTML_label .= '<br /><img src="'.SKIN_URL.'sym_info.gif"> '.__('Remember to work on the plain-text content, otherwise many receivers will not see anything.');
	$TEXT_label = __('This content will be used in the plain-text part of the newsletter.');
	for ($c=0;$c<count($categories);$c++)  {
		if ($activeModules[$directory]['text_only'] != 'yes')  {  // HTML-Platzhalter
			$query =	"INSERT INTO ".CPO_PLACEHOLDERS." "
						."(templates_id, ttype, fieldname, pos, ddata) VALUES ("
						."'".$mod_template_id."', "
						."'2', " 
						."'".addslashes($categories[$c])."', "
						."'". ( $n++ ) ."', '"
						.serialize(array('label'=>$HTML_label))
						."')";
			DEBUG(1, $query, __FILE__, __LINE__);
			$db_c = new DB;
			$db_c->query($query);
		}
		if ($activeModules[$directory]['text_only'] != 'no')  {  // Text-Platzhalter
			$query =	"INSERT INTO ".CPO_PLACEHOLDERS." "
						."(templates_id, ttype, fieldname, pos, ddata) VALUES ("
						."'".$mod_template_id."', "
						."'4', " 
						."'".addslashes($categories[$c])."', "
						."'".( $n++ ) ."', '"
						.serialize(array('label'=>$TEXT_label))
						."')";
			DEBUG(1, $query, __FILE__, __LINE__);
			$db_c = new DB;
			$db_c->query($query);
		}
	}
	
	// deleting cronjobs and scedules

	if ($_POST['cpoNewsletterDo']['cancel_cronjob'] == 'cancel')  {
		$query = "TRUNCATE TABLE ".$dbPrefix."_mod_newsletter_cronjob";
		DEBUG(1, $query, __FILE__, __LINE__); 
		$db = new DB;
		$db->query($query);
	    $message[] = __('All cronjobs were succesfully deleted!');
	}

	if (is_array($_POST['cpoNewsletterDo']['schedules']))  {
		$db = new DB;
		foreach ($_POST['cpoNewsletterDo']['schedules'] AS $id)  {
			$query = "DELETE FROM ".$dbPrefix."_mod_newsletter_schedule WHERE id=".$id;
			DEBUG(1, $query, __FILE__, __LINE__); 
			$db->query($query);
		}
		$message[] = __('The selected schedules were successfully deleted!');
	}

	if ($activeModules[$directory]['log'] == 'yes') logaction('Newsletter settings updated', '');
    $message[] = __('Module settings were updated!');
}

// Frontendaktionen **************************************************************************************************

$submitted = false;
$eMailGiven = false;
$success = '';
if (isset($_REQUEST['subscribe']) || isset($_REQUEST['unsubscribe']))  $submitted = true;
if (isset($_REQUEST['eMail']) && $_REQUEST['eMail']!='' && is_email_valid($_REQUEST['eMail']))  $eMailGiven = true;
$email = $_REQUEST['eMail'];

// Insert values into Database
if ($eMailGiven && check_receiver($_REQUEST['eMail']) === FALSE && is_email_valid($email))  {		// not in the list
	if ($activeModules[$directory]['opt'] != 'yes')  {		// no confirmation required
		if ($_REQUEST['action'] == "subscribe" && $eMailGiven && isset($_REQUEST['subscribe'])) {

			$all_necessary = true;
			if (isset($_POST['personal_necessary']))  {
				foreach($_POST['personal_necessary'] AS $check)  {
					if (!isset($_POST['receiver_personal'][$check]) || $_POST['receiver_personal'][$check] == '')  {
						$message[] = sprintf($activeModules[$directory]['necessary_data'],$check);
						$all_necessary = false;
					}
				}
			}
			if ($all_necessary == false) {
				$_GET['action'] = 'modify';
				$_POST['list'] = '';
				$_GET['nr'] = $_POST['id'];
				return;
			}
			// Captcha-Check
			if ($activeModules[$directory]['captcha'] == "yes") {
				if(isset($_SESSION['captcha_spam']) AND $_POST["sicherheitscode"] == $_SESSION['captcha_spam']){ 
					unset($_SESSION['captcha_spam']);
				} else {
					$message[] = $activeModules[$directory]['captcha_error'];
					//$_GET['action'] = 'modify';
					//$_POST['list'] = '';
					//$_GET['nr'] = $_POST['id'];
					return;
				}
			}
			
			$now			= time();
			$email			= $_REQUEST['eMail'];
			$email_md5		= md5($_REQUEST['eMail'].time());
			$new_passwd     = substr(md5(time().$email), 0, 5);
			$new_passwd_md5 = md5($new_passwd);
			$c_datum		= date ( "Y-m-d H:m:i" ,time() );

            $personal = (is_array($_POST['receiver_personal'])) ? "'".addslashes(serialize($_POST['receiver_personal']))."'" : 'NULL' ;

			$query = 'INSERT INTO '.$dbPrefix.'_mod_newsletter_adresses (newsletter, email, name, password, hash, time, ctime, active, rank, personalize) VALUES ("'.$directory.'", "'.addslashes($_REQUEST['eMail']).'", "'.addslashes($_REQUEST['Name']).'", "'.$new_passwd_md5.'", "'.$email_md5.'", "'.$c_datum.'", "'.$now.'", 1, '.$activeModules[$directory]['default_rank'].', '.$personal.')';
			$db->query($query);
			
			ini_set('sendmail_from', $activeModules[$directory]['sender_email']);

			$unconfirmed_content = $activeModules[$directory]['unconfirmed_content'];
				$replacer = array();
                $replacer[newsletterPlaceholder("NL-MAIL")] = $email;
                $replacer[newsletterPlaceholder("NL-PASSWORD")] = $new_passwd;
                $replacer[newsletterPlaceholder("NL-UNSCRIBE-LINK")] = BASE_URL.$activeModules[$directory]['directory'].'/index.php?action=unscribe&hash='.$email_md5;
			$unconfirmed_content = preg_replace(array_keys($replacer), array_values($replacer), $unconfirmed_content);

			// Mail to the new Subscriber
			mail (
			$email,
			$activeModules[$directory]['unconfirmed_subject'],
			decode_entities($unconfirmed_content),
			"FROM: ".$activeModules[$directory]['sender_email']."\n"
				.'Content-Type: text/plain; format=flowed; charset="iso-8859-1"');
			// Mail to the admin
			if ($activeModules[$directory]['notice_to_admin'] == 'yes')  {
                $notice_to_admin_content = $activeModules[$directory]['notice_to_admin_content'];
                $notice_to_admin_content = preg_replace(array_keys($replacer), array_values($replacer), $notice_to_admin_content);
				mail (
				$activeModules[$directory]['admin_email'],
				$activeModules[$directory]['notice_to_admin_subject'],
				decode_entities($notice_to_admin_content),
				"FROM: ".$activeModules[$directory]['sender_email']."\n"
				    .'Content-Type: text/plain; format=flowed; charset="iso-8859-1"');
			}
//			ini_restore('sendmail_from');
			$success = "subscribe_2";
		}
	}

	if ($activeModules[$directory]['opt'] == 'yes')  {
		if ($_REQUEST['action'] == "subscribe" && $eMailGiven && isset($_REQUEST['subscribe'])) {

			$all_necessary = true;
			if (is_array($_POST['personal_necessary']))  {
				foreach($_POST['personal_necessary'] AS $check)  {
					if (!isset($_POST['receiver_personal'][$check]) || $_POST['receiver_personal'][$check] == '')  {
						$message[] = sprintf($activeModules[$directory]['necessary_data'],$check);
						$all_necessary = false;
					}
				}
			}
			if ($all_necessary == false) {
				$_GET['action'] = 'modify';
				$_POST['list'] = '';
				$_GET['nr'] = $_POST['id'];
				return;
			}
			// Captcha-Check
			if ($activeModules[$directory]['captcha'] == "yes") {
				if(isset($_SESSION['captcha_spam']) AND $_POST["sicherheitscode"] == $_SESSION['captcha_spam']){ 
					unset($_SESSION['captcha_spam']);
				} else {
					$message[] = $activeModules[$directory]['captcha_error'];
					//$_GET['action'] = 'modify';
					//$_POST['list'] = '';
					//$_GET['nr'] = $_POST['id'];
					return;
				}
			}
			
			
			$now        = time();
			$email_md5  = md5($_REQUEST['eMail'].time());

			$new_passwd     = substr(md5(time().$email), 0, 5);
			$new_passwd_md5 = md5($new_passwd);

            $personal = (is_array($_POST['receiver_personal'])) ? "'".addslashes(serialize($_POST['receiver_personal']))."'" : 'NULL' ;

			$query = "INSERT INTO ".$dbPrefix."_mod_newsletter_adresses (newsletter, email, name, password, hash, time, ctime, rank, personalize) VALUES ('".$directory."', '".addslashes($_REQUEST['eMail'])."', '".addslashes($_REQUEST['Name'])."', '".$new_passwd_md5."', '".$email_md5."', '0000-00-00 00:00:00', '".$now."', ".$activeModules[$directory]['default_rank'].", ".$personal.")";
			$db->query($query);

			ini_set('sendmail_from', $activeModules[$directory]['sender_email']);

			$confirmation_mail_content = $activeModules[$directory]['confirmation_mail_content'];
				$replacer = array();
                $replacer[newsletterPlaceholder("NL-MAIL")] = $_REQUEST['eMail'];
                $replacer[newsletterPlaceholder("NL-PASSWORD")] = $new_passwd;
                $replacer[newsletterPlaceholder("NL-CONFIRMATION-LINK")] = BASE_URL.$activeModules[$directory]['directory'].'/index.php?action=auth&hash='.$email_md5;
                $replacer[newsletterPlaceholder("NL-DELAY")] = $activeModules[$directory]['confirm_delay'];
			$confirmation_mail_content = preg_replace(array_keys($replacer), array_values($replacer), $confirmation_mail_content);
			
			mail (
			$_REQUEST['eMail'],
			$activeModules[$directory]['confirmation_mail_subject'],
			decode_entities($confirmation_mail_content),
			"FROM: ".$activeModules[$directory]['sender_email']."\n"
				.'Content-Type: text/plain; format=flowed; charset="iso-8859-1"');
//			ini_restore('sendmail_from');

			$success = "subscribe_1";
		}
	}
} elseif ($eMailGiven && check_receiver($_REQUEST['eMail']) == 2 )  {	// already banned
	$message[] = sprintf($activeModules[$directory]['hint_banned'], htmlspecialchars($_REQUEST['eMail'], ENT_COMPAT, 'ISO-8859-15'));
    return;
} elseif ( $eMailGiven && (check_receiver($_REQUEST['eMail']) == 1 OR check_receiver($_REQUEST['eMail']) == 0) &&  isset($_REQUEST['subscribe']))  {	// already in the list
	$message[] = sprintf($activeModules[$directory]['hint_already_in_list'], htmlspecialchars($_REQUEST['eMail'], ENT_COMPAT, 'ISO-8859-15'));
} elseif (!is_email_valid($_REQUEST['eMail']) && isset($_REQUEST['subscribe']))  {	// invalid eMail
	$message[] = sprintf($activeModules[$directory]['hint_on_email_error'], htmlspecialchars($_REQUEST['eMail'], ENT_COMPAT, 'ISO-8859-15'));
}


// Confirmation-Link is klicked
if ($activeModules[$directory]['opt'] == 'yes')  {
	if ($_REQUEST['action'] == "auth" && isset($_REQUEST['hash']))  {
		$query = "SELECT * FROM ".$dbPrefix."_mod_newsletter_adresses WHERE hash = '".addslashes($_REQUEST['hash'])."' AND time = '0000-00-00 00:00:00'";
		DEBUG(1, $query, __FILE__, __LINE__); 
		$db = new DB;
		$db->query($query);
		if ( $db->num_rows()>0 )  {
			while($db->next_record()):
				$email     = $db->v("email");
				$email_md5 = $_REQUEST['hash'];
				$c_datum = date ( "Y-m-d H:m:i" ,time() );
				$query = "UPDATE ".$dbPrefix."_mod_newsletter_adresses SET time = '".$c_datum."', active = '1', rank = '".$activeModules[$directory]['default_rank']."' WHERE hash = '".addslashes($_REQUEST['hash'])."'";
				DEBUG(1, $query, __FILE__, __LINE__); 
				$db2 = new DB;
				$db2->query($query);

				ini_set('sendmail_from', $activeModules[$directory]['sender_email']);

				$confirmed_content = $activeModules[$directory]['confirmed_content'];
                    $replacer = array();
                    $replacer[newsletterPlaceholder("NL-MAIL")] = $email;
                    $replacer[newsletterPlaceholder("NL-PASSWORD")] = $db->v("password");
                    $replacer[newsletterPlaceholder("NL-UNSCRIBE-LINK")] = BASE_URL.$activeModules[$directory]['directory'].'/index.php?action=unscribe&hash='.$email_md5;
                $confirmed_content = preg_replace(array_keys($replacer), array_values($replacer), $confirmed_content);

				// Mail to the new Subscriber
				mail (
				$email,
				$activeModules[$directory]['confirmed_subject'],
				decode_entities($confirmed_content),
				"FROM: ".$activeModules[$directory]['sender_email']."\n"
				    .'Content-Type: text/plain; format=flowed; charset="iso-8859-1"');
				// Mail to the admin
				if ($activeModules[$directory]['notice_to_admin'] == 'yes')  {
                    $notice_to_admin_content = $activeModules[$directory]['notice_to_admin_content'];
                    $notice_to_admin_content = preg_replace(array_keys($replacer), array_values($replacer), $notice_to_admin_content);
					mail (
					$activeModules[$directory]['admin_email'],
					$activeModules[$directory]['notice_to_admin_subject'],
					decode_entities($notice_to_admin_content),
					"FROM: ".$activeModules[$directory]['sender_email']."\n"
        				.'Content-Type: text/plain; format=flowed; charset="iso-8859-1"');
				}
//				@ini_restore('sendmail_from');

			endwhile;

			$success = "subscribe_2";
		} else {
			$message[] = $activeModules[$directory]['wrong_hash']; 
			if ($activeModules[$directory]['log'] == 'yes') logaction('Wrong confirmation hash', '');
		}
	}
}

// Unscribing
if ($_REQUEST['action'] == "subscribe" && $eMailGiven && isset($_REQUEST['unscribe'])) {
    // Captcha-Check
    if ($activeModules[$directory]['captcha'] == "yes") {
        if(isset($_SESSION['captcha_spam']) AND $_POST["sicherheitscode"] == $_SESSION['captcha_spam']){ 
            unset($_SESSION['captcha_spam']);
        } else {
            $message[] = $activeModules[$directory]['captcha_error'];
            $_GET['action'] = 'modify';
            $_POST['list'] = '';
            $_GET['nr'] = $_POST['id'];
            return;
        }
    }
    $query = "SELECT * FROM ".$dbPrefix."_mod_newsletter_adresses WHERE email = '".addslashes($_REQUEST['eMail'])."' AND newsletter='".$directory."'";
    DEBUG(1, $query, __FILE__, __LINE__); 
    $db = new DB;
    $db->query($query);
    if ( $db->num_rows()>0 ) {
		$db->next_record();
		$unscribe_content = $activeModules[$directory]['unscribe_content'];
            $replacer = array();
            $replacer[newsletterPlaceholder("NL-MAIL")] = $db->v('email');
            $replacer[newsletterPlaceholder("NL-UNSCRIBE-LINK")] = BASE_URL.$activeModules[$directory]['directory'].'/index.php?action=unscribe&hash='.$db->v('hash');
        $unscribe_content = preg_replace(array_keys($replacer), array_values($replacer), $unscribe_content);
		// Mail to the Unscriber
		$message[] = $activeModules[$directory]['hint_to_unsrciber'];
		mail (
		$email,
		$activeModules[$directory]['unscribe_subject'],
		decode_entities($unscribe_content),
		"FROM: ".$activeModules[$directory]['sender_email']."\n"
            .'Content-Type: text/plain; format=flowed; charset="iso-8859-1"');
		// Mail to the admin
		if ($activeModules[$directory]['notice_to_admin'] == 'yes')  {
            $unscribe_to_admin_content = $activeModules[$directory]['unscribe_to_admin_content'];
            $unscribe_to_admin_content = preg_replace(array_keys($replacer), array_values($replacer), $unscribe_to_admin_content);
			mail (
			$activeModules[$directory]['admin_email'],
			$activeModules[$directory]['unscribe_to_admin_subject'],
			decode_entities($unscribe_to_admin_content),
			"FROM: ".$activeModules[$directory]['sender_email']."\n"
                .'Content-Type: text/plain; format=flowed; charset="iso-8859-1"');
		}
//		@ini_restore('sendmail_from');
	} else {
		$message[] = sprintf($activeModules[$directory]['hint_no_subsrciber'], htmlspecialchars($_REQUEST['eMail'], ENT_COMPAT, 'ISO-8859-15'));
	}
} elseif ($_REQUEST['action'] == "subscribe" && isset($_REQUEST['unscribe']))  {
	$message[] = sprintf($activeModules[$directory]['hint_no_subsrciber'], htmlspecialchars($_REQUEST['eMail']));
}

// forgotten password
// was tun? wir erzeugen ein neues Password und setzen dies als neuen hash
// dann senden wir ein Mail an die Adresse mit der Bitte um Anklicken eines Links und dem neuen Passwort
// diese Seite berschreibt dann das alte Passwort mit dem hash und somit ist das neue Passwort gltig
if ($_REQUEST['action'] == "login" && $eMailGiven && isset($_REQUEST['subscribe3'])) {
    $query = "SELECT * FROM ".$dbPrefix."_mod_newsletter_adresses WHERE email = '".addslashes($_REQUEST['eMail'])."'";
    DEBUG(1, $query, __FILE__, __LINE__); 
    $db = new DB;
    $db->query($query);
    if ( $db->num_rows()>0 ) {
		$db->next_record();

		$email			= addslashes($_REQUEST['eMail']);
		$new_passwd     = substr(md5(time().$email), 0, 5);
		$new_passwd_md5 = md5($new_passwd);

		$query = "UPDATE ".$dbPrefix."_mod_newsletter_adresses SET hash='".$new_passwd_md5."' WHERE email='".$email."' AND newsletter='".$directory."'";
		$db->query($query);
		
		ini_set('sendmail_from', $activeModules[$directory]['sender_email']);
		$unscribe_content = $activeModules[$directory]['forgotten_password_content'];
            $replacer = array();
            $replacer[newsletterPlaceholder("NL-MAIL")] = $email;
            $replacer[newsletterPlaceholder("NL-NEW-PASSWORD")] = $new_passwd;
            $replacer[newsletterPlaceholder("NL-NEW-PASSWORD-LINK")] = BASE_URL.$activeModules[$directory]['directory'].'/index.php?action=reset_password&hash='.$new_passwd_md5;
        $unscribe_content = preg_replace(array_keys($replacer), array_values($replacer), $unscribe_content);
		// Mail to the Alzheimer
		$message[] = $activeModules[$directory]['hint_on_password_verification'];
		mail (
		$email,
		$activeModules[$directory]['forgotten_password_subject'],
		decode_entities($unscribe_content),
		"FROM: ".$activeModules[$directory]['sender_email']."\n"
            .'Content-Type: text/plain; format=flowed; charset="iso-8859-1"');
		// Mail to the admin
//		ini_restore('sendmail_from');
	} else {
		$message[] = sprintf($activeModules[$directory]['hint_no_subsrciber'], htmlspecialchars($_REQUEST['eMail'], ENT_COMPAT, 'ISO-8859-15'));
	}
} elseif ($_REQUEST['action'] == "login" && isset($_REQUEST['subscribe3']))  {
	$message[] = sprintf($activeModules[$directory]['hint_no_subsrciber'], htmlspecialchars($_REQUEST['eMail'], ENT_COMPAT, 'ISO-8859-15'));
}

// forgotten password confirmed
if ($_REQUEST['action'] == "reset_password" && isset($_REQUEST['hash']))  {
    $query = "SELECT id FROM ".$dbPrefix."_mod_newsletter_adresses WHERE hash = '".addslashes($_REQUEST['hash'])."'";
    DEBUG(1, $query, __FILE__, __LINE__); 
    $db = new DB;
    $db->query($query);
    if ( $db->num_rows()>0 )  {  // this one is real!
        $db->next_record();
		$id_to_reset = $db->v('id');
		$email = $db->v('email');
		$new_hash = md5(substr(md5(time().$email), 0, 5));

		$query = "UPDATE ".$dbPrefix."_mod_newsletter_adresses SET hash='".$new_hash."', password='".addslashes($_REQUEST['hash'])."' WHERE id=".$id_to_reset;
		$db->query($query);
		$message[] = $activeModules[$directory]['hint_on_password_change'];
	} else {
		$message[] = $activeModules[$directory]['hint_on_password_error'];
	}
} elseif ($_REQUEST['action'] == "reset_password" && !isset($_REQUEST['hash']))  {
	$message[] = $activeModules[$directory]['hint_on_password_error'];
}


// Login to the User-Frontend
if ($_REQUEST['action'] == "login" && $eMailGiven && isset($_REQUEST['subscribe2']) && isset($_REQUEST['password'])) {
    $query = "SELECT * FROM ".$dbPrefix."_mod_newsletter_adresses WHERE password = '".md5($_REQUEST['password'])."' AND email = '".addslashes($_REQUEST['eMail'])."' AND newsletter='".$directory."'";
    DEBUG(1, $query, __FILE__, __LINE__); 
    $db = new DB;
    $db->query($query);
    if ( $db->num_rows()>0 )  {
        while($db->next_record()):
			$data_rows = '';
			$receiver_name = $db->v('name');
			$receiver_email = $db->v('email');
			$receiver_personal = unserialize($db->v('personalize'));
			include(CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/inc_personalize.inc.php');
			
			if ($activeModules[$directory]['use_categories'] == 'yes')  { 
				$receiver_categories = $db->v('categories');
				if ($receiver_categories == "all")  {
					$cat_all = '<input type="radio" name="categories" value="all" checked>';
					$cat_select = '<input type="radio" name="categories" value="selection">';
				} else {
					$cat_all = '<input type="radio" name="categories" value="all">';
					$cat_select = '<input type="radio" name="categories" value="selection" checked>';
				}
				$categories = explode(";",$activeModules[$directory]['categories']);
				for ($c=0;$c<count($categories);$c++)  {
					if (empty($categories[$c])) continue;
					if (strpos($receiver_categories, $categories[$c]) !== false)  {
						$cat_check .= '<input type="checkbox" name="categorie_check[]" value="'.$categories[$c].'" checked> '.$categories[$c].'<br>';
					} else {
						$cat_check .= '<input type="checkbox" name="categorie_check[]" value="'.$categories[$c].'"> '.$categories[$c].'<br>';
					}
				}
			} else {
				$cat_all	= __('deactivated');
				$cat_select	= __('deactivated');
				$cat_check	= __('deactivated');
			}
		endwhile;

        $replacer = array();
        $replacer[newsletterPlaceholder("NL-NAME")] = $receiver_name;
        $replacer[newsletterPlaceholder("NL-MAIL")] = $receiver_email.'<input type="hidden" name="hash_4_chg" value="'.md5($_REQUEST['password']).'"><input type="hidden" name="eMail" value="'.$receiver_email.'">';
        $replacer[newsletterPlaceholder("NL-NEW-PASSWORD-LINK")] = BASE_URL.$activeModules[$directory]['directory'].'/index.php?action=reset_password&hash='.$new_passwd_md5;
        $replacer[newsletterPlaceholder("NL-CAT-ALL")]    = $cat_all;
        $replacer[newsletterPlaceholder("NL-CAT-SELECT")] = $cat_select;
        $replacer[newsletterPlaceholder("NL-CAT-CHECK")]  = $cat_check;
        $replacer[newsletterPlaceholder("NL-DATA-ROWS")]  = $data_rows;
	$activeModules[$directory]['user_page'] = preg_replace(array_keys($replacer), array_values($replacer), $activeModules[$directory]['user_page']);

	$success = "user_profile";
	} else {
		$message[] = $activeModules[$directory]['hint_on_password_error'];
	}
} elseif ($_REQUEST['action'] == "login" && isset($_REQUEST['subscribe2'])) {
	$message[] = $activeModules[$directory]['hint_on_password_error'];
}

// change category settings, name and personalized settings
if (isset($_REQUEST['change_profile']))  {
    $query = "SELECT * FROM ".$dbPrefix."_mod_newsletter_adresses WHERE password = '".addslashes($_REQUEST['hash_4_chg'])."' AND email = '".addslashes($_REQUEST['eMail'])."' AND newsletter='".$directory."'";
    DEBUG(1, $query, __FILE__, __LINE__); 
    $db = new DB;
    $db->query($query);

    $all_necessary = true;
    if (isset($_POST['personal_necessary']))  {
        foreach($_POST['personal_necessary'] AS $check)  {
            if (!isset($_POST['receiver_personal'][$check]) || $_POST['receiver_personal'][$check] == '')  {
                $message[] = sprintf($activeModules[$directory]['necessary_data'],$check);
                $all_necessary = false;
            }
        }
    }
    if (isset($_POST['receiver_personal']))  {
        $data_personalize = ", personalize = '".serialize($_POST['receiver_personal'])."'";
    } else {
        $data_personalize = ", personalize = NULL";
    }
    if ($all_necessary == false) {
        $_GET['action'] = 'modify';
        $_POST['list'] = '';
        $_GET['nr'] = $_POST['id'];
        return;
    }

    if ( $db->num_rows()>0 )  {
        while($db->next_record()):
			if ($_REQUEST['categories'] == 'all') $categories = 'all';
			if ($_REQUEST['categories'] == 'selection')  {
				$categories = '';
				for ($c=0;$c<count($_REQUEST['categorie_check']);$c++)  {
					if($c > 0) $categories .= ";";
					$categories .= $_REQUEST['categorie_check'][$c];
				}
			}
			$query = "UPDATE ".$dbPrefix."_mod_newsletter_adresses SET name='".addslashes($_REQUEST['name'])."', categories='".$categories."'".$data_personalize." WHERE password = '".addslashes($_REQUEST['hash_4_chg'])."' AND email = '".addslashes($_REQUEST['eMail'])."' AND newsletter='".$directory."'";
			DEBUG(1, $query, __FILE__, __LINE__); 
			$db2 = new DB;
			$db2->query($query);
		endwhile;
	}
	$success = "user_profile_changed";
	$message[] = $activeModules[$directory]['profile_change_successful'];
}

// change password
if (isset($_REQUEST['change_password']))  {
	if (isset($_REQUEST['old_password']) && 
		isset($_REQUEST['new_password']) && 
		isset($_REQUEST['new_password_double']) && 
		$_REQUEST['new_password'] == $_REQUEST['new_password_double'] &&
		trim($_REQUEST['old_password']) != '' &&
		trim($_REQUEST['new_password']) != '' &&
		trim($_REQUEST['new_password_double']) != ''	)  {
		$query = "SELECT * FROM ".$dbPrefix."_mod_newsletter_adresses WHERE password = '".md5($_REQUEST['old_password'])."' AND email = '".addslashes($_REQUEST['eMail'])."' AND newsletter='".$directory."'";
        //echo $query.'<br />';
		DEBUG(1, $query, __FILE__, __LINE__); 
		$db = new DB;
		$db->query($query);
		if ( $db->num_rows()>0 )  {
			while($db->next_record()):
				$query = "UPDATE ".$dbPrefix."_mod_newsletter_adresses SET password='".md5($_REQUEST['new_password'])."' WHERE password = '".md5($_REQUEST['old_password'])."' AND email = '".addslashes($_REQUEST['eMail'])."' AND newsletter='".$directory."'";
				DEBUG(1, $query, __FILE__, __LINE__); 
				$db2 = new DB;
				$db2->query($query);
                //echo $query.'<br />';
			endwhile;
			$message[] = $activeModules[$directory]['password_change_successful'];
		} else {
			$message[] = __('No match found!');
		}
		$success = "user_profile_changed";
	} else {
		$message[] = $activeModules[$directory]['password_change_error'];
	}
}

?>