<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Newsletter"				                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

=== Version 4.3e / January 2014 ===

*/

if (!defined('CPO')) exit;

// use rubric_id from session
if (isset($_SESSION['SID_rubric_id'])) {
    $cpoRubric['id'] = $_SESSION['SID_rubric_id'];
}

// Rubrik-ID fr Newsletter auslesen
$query = "SELECT id "
		."FROM ".$dbPrefix."_rubric "
		."WHERE (name = '".$activeModules[$directory]['newsletter_rubric']."' OR id = '".$activeModules[$directory]['newsletter_rubric']."')";
DEBUG(1, $query, __FILE__, __LINE__);
$db->query($query);
$db->next_record();
if ($_SESSION['SID_rubric_id'] != $db->v('id'))  {
	$_SESSION['SID_rubric_id'] = $db->v('id');
	$message[] .= __('The actual rubric has been changed to <b>'.$activeModules[$directory]['newsletter_rubric'].'!</b>');
}

$replacebr = array('<br>','<br />','<BR>','<BR />');
$withbr    = "\n";
$replace = array('</p>','</P>','</h1>','</h2>','</h3>','</h4>','</h5>','</h6>','</H1>','</H2>','</H3>','</H4>','</H5>','</H6>','</ul>','</UL>','</ol>','</OL>','</div>','</DIV>');
$with    = "\n\n";

require(CPO_BASEDIR.'_include/var_category.php');
require(CPO_BASEDIR.'_include/check.php');

$views = array('list');
if ($_REQUEST['list'] == 'saving') $views = array('saving');
if (isset ($_REQUEST['title']) && $_REQUEST['title']=='') {
	$views = array('list');
	$message[] = __('You need to fill in a title for the newsletter!');
}

if ($activeModules[$directory]['use_categories'] == 'yes')  {
	$categories = explode(";",$activeModules[$directory]['header'].";".$activeModules[$directory]['categories'].";".$activeModules[$directory]['footer']);
} elseif ($activeModules[$directory]['use_categories'] == 'no')  {
	$categories = explode(";",$activeModules[$directory]['header'].";".$activeModules[$directory]['main'].";".$activeModules[$directory]['footer']);
}

if (!license($activeModules[$directory]['lkey'],$activeModules[$directory]['mod_id']))  {
	$disabled = ' disabled="disabled"';
	$disabled_hint = '&nbsp;<img src="'.SKIN_URL.'sym_info.gif">&nbsp;'.__('available in the registered version');
}

while ($nextview = array_shift($views)) {
    switch ($nextview) {
    case 'list': // {{{
        require(CPO_BASEDIR.'_include/header.php');

		printPageHeader(
			__('Compose newsletter'),
			__('In this view you can compose a new newsletter out of existing articles.'),
			modHelp('actions','newsletter'),
			true,
			'modules'
		);

		require(CPO_BASEDIR."_include/message.php");

		$query       = 'SELECT nr, titel, name FROM '.CPO_NEWS.', '.CPO_RUBRIC.' WHERE rubric_id=id';
		$db = new DB;
		$db->query($query);
		while($db->next_record()) {
			$articlelist[$db->v('nr')] = $db->v('titel')." (".__('Rubric:')." ". $db->v('name').")";
		}

		
		echo '<form method="post" action="'.$_SERVER['PHP_SELF'].'" name="composer">';
		echo '<input type="hidden" name="list" value="compose">';

		if (is_array($_REQUEST['articles'])) {
			foreach($_REQUEST['articles'] AS $articleNr)  {
				$_REQUEST[$_REQUEST['category']][] = $articleNr;
			}
		}
		
		// first we need a list of the existing published articles

		$where = "FROM ".CPO_NEWS.", ".CPO_RUBRIC." "
				."WHERE ";

		$articlestates = $cpoSystem['release'] 
			? 'artikel_archiv<2 AND freigabe='.STATE_RELEASED.' ' 
			: 'artikel_archiv<1 AND freigabe!='.STATE_BLOCKED.' ';
		$now = time();

		$where .= $articlestates
				 ."AND pub_datum<='".date('Y-m-d H:i:s', $now)."' "
				 ."AND verfallsdatum>='".date('Y-m-d H:i:s', $now)."' "
				 .'AND rubric_id=id ';

		$query_count = 'SELECT COUNT(*) '.$where;
		$query       = 'SELECT rubric_id, commentary, verfallsdatum, templates_id, nr, idx, email, autor, pub_datum, titel, initial, freigabe, changer, last_modify, name '
					  .$where
					  .'ORDER BY pub_datum DESC';
		$db = new DB;
		$db->query($query_count);
		$db->next_record();
		$max_anzahl = $db->v('COUNT(*)');

		$db->query($query);
		$anzahl = $db->num_rows();

		$articleSeparator = '';
        echo '<table class="colored" style="width: 100%;">';
        echo '<thead><tr>';

        echo '<th><span>'.__('Adding articles to the newsletter').'</span></th>';

		echo '</tr></thead><tbody>';
		echo '<tr><td>'.__('First choose the articles (multiple choices possible), then assign them to a category and finally add this to the list').'</td></tr>';
		echo '<tr><td><select name="articles[]" size="10" multiple="multiple">';
		while($db->next_record()) {
			$db_name          = $db->v('name');
			$db_nr            = $db->v('nr');
			$db_titel         = $db->v('titel');
			$db_last_modify   = $db->v('last_modify');
			echo '<option value="'.$db_nr.'">'.htmlspecialchars($db_titel, ENT_COMPAT, 'ISO-8859-15')." (".__('Rubric:')." ".htmlspecialchars($db_name, ENT_COMPAT, 'ISO-8859-15')." / ".date('d.m.Y',strtotime($db_last_modify)).")</option>"."\n";
		}
		echo '</select></td></tr><tr><td>';
		echo __('assign to').'<br />';
		echo '<select name="category">';
		for ($c=0;$c<count($categories);$c++)  {
			echo '<option value="'.$categories[$c].'">'.$categories[$c].'</option>'."\n";
		}
		echo '</select></td></tr>';

		
		
		echo '<tr><td><input type="submit" class="button" value="'.__('add article(s) to newsletter').'"></td></tr>';
		echo '</tbody></table>';


		// Preview

        echo '<table class="colored" style="width: 100%;">';
        echo '<thead><tr>';

        echo '<th><span>'.__('Preview').'</span></th>';

		echo '</tr></thead><tbody>';
		echo '<tr><td>'.__('This is the preview showing your actual compilation.').'</td></tr>';
		echo '<tr><td>';
		
		echo $activeModules[$directory]['html_header'];

		for ($c=0;$c<count($categories);$c++)  {
			if (is_array($_REQUEST[$categories[$c]])) {
				foreach($_REQUEST[$categories[$c]] AS $articleNr)  {

				$query = 'SELECT rubric_id, commentary, verfallsdatum, templates_id, nr, idx, email, autor, pub_datum, titel, initial, freigabe, changer, last_modify '
						.'FROM '.CPO_NEWS.' '
						.'WHERE nr='.(int)$articleNr;
				$now = time();

				$db = new DB;
				$db->query($query);

				$GLOBALS['lastUpdated'] = 0;
				$db->next_record();
				$db_template      = $db->v('templates_id');
				$db_nr            = $db->v('nr');
				$db_idx           = $db->v('idx');
				$db_email         = $db->v('email');
				$db_autor         = $db->v('autor');
				$db_changer       = $db->v('changer');
				$db_pub_datum     = $db->v('pub_datum');
				$db_verfallsdatum = $db->v('verfallsdatum');
				$db_commentary    = $db->v('commentary');
				$db_titel         = $db->v('titel');
				$db_initial       = $db->v('initial');
				$db_freigabe      = $db->v('freigabe');
				$db_rubric_id     = $db->v('rubric_id');
				$db_last_modify   = $db->v('last_modify');
				if ($GLOBALS['lastUpdated']<strtotime($db_last_modify)) {
					$GLOBALS['lastUpdated'] = strtotime($db_last_modify);
				}

//				$pagetype = 'detail';
				require(CPO_BASEDIR.'_include/select_template.php');
				}
			}
		}

		echo $activeModules[$directory]['html_footer'];
		
		echo '</td></tr>';
		echo '</tbody></table>';

		$saveList = '';

		for ($c=0;$c<count($categories);$c++)  {
        echo '<table class="colored" style="width: 100%;">';
        echo '<thead><tr>';

        echo '<th><span>'.$categories[$c].'</span></th>';

		echo '</tr></thead><tbody>';
//			echo '<b>'.$categories[$c].':</b><br />';
			if (is_array($_REQUEST[$categories[$c]])) {
				foreach($_REQUEST[$categories[$c]] AS $articleNr)  {
					$saveList .= '<input type="hidden" name="'.$categories[$c].'[]" value="'.$articleNr.'">';
					echo '<tr>';
					echo '<td>';
					echo '<input type="checkbox" name="'.$categories[$c].'[]" value="'.$articleNr.'" checked="checked">'.$articlelist[$articleNr].'<br />';
					echo '</td>';
					echo '</tr>';
				}
			} else {
				echo '<tr>';
				echo '<td class="leftrow">';
				echo __('No articles assigned yet!').'<br />';
				echo '</td>';
				echo '</tr>';
			}
		echo '<tr><td><input type="submit" class="button" value="'.__('update').'"></td></tr>';
		echo '</tbody></table>';
		}
		echo '</form>';


		echo '<form method="post" action="'.$_SERVER['PHP_SELF'].'" name="saving">';
		echo '<input type="hidden" name="list" value="saving">';
        echo '<table class="colored" style="width: 100%;">';
        echo '<thead><tr>';

        echo '<th><span>'.__('Saving the newsletter').'</span></th>';

		echo '</tr></thead><tbody>';
		echo '<tr><td>'.__('Please fill in a title for the new newsletter:').'</td></tr>';
		echo '<tr><td><input type="text" name="title" class="text inputwidth" value="'.$_REQUEST['title'].'">';
		echo $saveList;
		echo '</td></tr>';
		echo '<tr><td>';
		echo '<input type="submit" class="button" value="'.__('save articles as new newsletter').'"'.$disabled.'>'.$disabled_hint;
		echo '</td></tr>';
		echo '</tbody></table>';
		echo '</form>';
		
		require(CPO_BASEDIR."_include/message.php");
		break;
    case 'saving': // {{{

		$data = array();

		$data = array(
			 'templates_id'   => $cpoRubricSettings['standard_template'], 
			 'titel'          => htmlspecialchars($_REQUEST['title'], ENT_COMPAT, 'ISO-8859-15'),
			 'rubric_id'      => $_SESSION['SID_rubric_id'], 
			 'commentary'     => '',
			 'datum'          => date('Y-m-d H:i:s', $now),
			 'verfallsdatum'  => '2036-01-01 00:00:00',
			 'pub_datum'      => date('Y-m-d H:i:s', $now),
			 'autor'          => $_SESSION['SID_user']['name'],
			 'email'          => $_SESSION['SID_user']['email'],
			 'initial'        => $_SESSION['SID_user']['initial'],
			 'releasedby'      => $_SESSION['SID_login'],
			 'changedBy'      => $_SESSION['SID_login']
		 );
		for ($c=0;$c<count($categories);$c++)  {
			if (is_array($_REQUEST[$categories[$c]])) {
				foreach($_REQUEST[$categories[$c]] AS $articleNr)  {
					ob_start();
					$query = 'SELECT rubric_id, commentary, verfallsdatum, templates_id, nr, idx, email, autor, pub_datum, titel, initial, freigabe, changer, last_modify '
							.'FROM '.CPO_NEWS.' '
							.'WHERE nr='.(int)$articleNr;
					$now = time();

					$db = new DB;
					$db->query($query);

					$GLOBALS['lastUpdated'] = 0;
					$db->next_record();
					$db_template      = $db->v('templates_id');
					$db_nr            = $db->v('nr');
					$db_idx           = $db->v('idx');
					$db_email         = $db->v('email');
					$db_autor         = $db->v('autor');
					$db_changer       = $db->v('changer');
					$db_pub_datum     = $db->v('pub_datum');
					$db_verfallsdatum = $db->v('verfallsdatum');
					$db_commentary    = $db->v('commentary');
					$db_titel         = $db->v('titel');
					$db_initial       = $db->v('initial');
					$db_freigabe      = $db->v('freigabe');
					$db_rubric_id     = $db->v('rubric_id');
					$db_last_modify   = $db->v('last_modify');
					if ($GLOBALS['lastUpdated']<strtotime($db_last_modify)) {
						$GLOBALS['lastUpdated'] = strtotime($db_last_modify);
					}
					require(CPO_BASEDIR.'_include/select_template.php');
					$data['content'][$categories[$c].' (html)']['html'] .= ob_get_contents();
					$data['content'][$categories[$c].' (text)']['text'] .= strip_tags(str_replace($replace, $with, str_replace($replacebr, $withbr, $data['content'][$categories[$c].' (html)']['html'])));
					ob_end_clean();
				}
			}
		}
		if ($nr = save_article($data)) {
			printPageHeader(
				__('Compose newsletter'),
				__('In this view you can compose a new newsletter out of existing articles.'),
				modHelp('actions','newsletter'),
				true,
				'modules'
			);
			$message[] = sprintf(__('The newsletter was saved as <i>%s</i>'), htmlspecialchars($_REQUEST['title'], ENT_COMPAT, 'ISO-8859-15'));
			$message[] = sprintf(__('Click the following link to edit the newsletter: <a href="%s/newsletter.php?action=articles_modify&nr=%s">Edit newsletter</a>'), BASE_URL.$activeModules[$moduleDirectory]['directory'], $nr);
			require(CPO_BASEDIR."_include/message.php");
		}
		break;
	}
}
?>