<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Newsletter"				                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

=== Version 4.3e / January 2014 ===

*/

if (!defined('CPO')) exit;

require_once('../_include/checkaccess.inc.php');

if (is_dir(substr(CPO_BASEDIR.$activeModules[$directory]['directory'].'/skin/'.$CPO['skin'],0,-1))) define('NL_SKIN_URL', BASE_REL.$activeModules[$directory]['directory'].'/skin/'.$CPO['skin']);
else define('NL_SKIN_URL', BASE_REL.$activeModules[$directory]['directory'].'/skin/conpresso/'); // Fallback to conpresso

// Newsletter-Rechte
$id = $_SESSION['SID_user']['id'];
$rights = $activeModules[$directory]['rights'][$id];
$permission_to_see = $rights{0};
$permission_receivers = $rights{1};
$permission_sending = $rights{2};

// use rubric_id from session
if (isset($_SESSION['SID_rubric_id'])) {
    $cpoRubric['id'] = $_SESSION['SID_rubric_id'];
}

// Rubrik-ID fr Newsletter auslesen
$query = "SELECT id "
		."FROM ".$dbPrefix."_rubric "
		."WHERE (name = '".$activeModules[$directory]['newsletter_rubric']."' OR id = '".$activeModules[$directory]['newsletter_rubric']."')";
DEBUG(1, 'Rubrik-ID fr Newsletter auslesen<br /><br />'.$query, __FILE__, __LINE__);
$db->query($query);
$db->next_record();
if ($_SESSION['SID_rubric_id'] != $db->v('id'))  {
	$_SESSION['SID_rubric_id'] = $db->v('id');
	$message[] .= __('The actual rubric has been changed to <b>'.$activeModules[$directory]['newsletter_rubric'].'!</b>');
}


require(CPO_BASEDIR.'_include/var_category.php');
require(CPO_BASEDIR.'_include/check.php');

$views = array('list');

while ($nextview = array_shift($views)) {
    switch ($nextview) {
    case 'list': // {{{
        require(CPO_BASEDIR.'_include/header.php');

        $art_count = 0;

        if (isset($_GET['pos'])) $_SESSION['SID_pagers']['articles'] = $_GET['pos'];
        if (empty($_GET['unr'])) $_GET['unr'] = -1;
        if (empty($_GET['dnr'])) $_GET['dnr'] = -1;

        $_q = "FROM ".CPO_NEWS." "
             ."WHERE artikel_archiv=0 "
             ."AND rubric_id='".addslashes($_SESSION['SID_rubric_id'])."' ";
        DEBUG(1, 'Artikelanzahl ermitteln<br /><br />'.$query, __FILE__, __LINE__);
        $db = new DB;
        $db->query('SELECT COUNT(*) '.$_q);
        $db->next_record();
        $max_data = $db->v('COUNT(*)');

        // if last article at article_pos got deleted, decrease article_pos
        if ($max_data<=$_SESSION['SID_pagers']['articles']) 
            $_SESSION['SID_pagers']['articles'] = $max_data-1;
        if ($_SESSION['SID_pagers']['articles']<0)
            $_SESSION['SID_pagers']['articles'] = 0;

		printPageHeader(
			__('Edit newsletters'),
			__('In this view you can manage the existing newsletters.'),
			modHelp('actions','newsletter'),
			true,
			'modules'
		);

        if ($max_data<=0) {
            $message[] =  __('No articles found.');
            include(CPO_BASEDIR.'_include/message.php');
            include(CPO_BASEDIR.'_include/footer.php');
            break;
        }

		require(CPO_BASEDIR."_include/message.php");

        // table header {{{
        echo '<table class="ruler" style="width: 100%;">';
        echo '<thead><tr>';

        if ($_SESSION['SID_stufe2']==1 && $cpoRubricSettings['sorting']=='sort_id desc') { 
            echo '<th style="width: 1%;"><span>'.'</span></th>';
        }

        echo '<th style="width: 74%;"><span>'.__('Newsletter/Author').'</span></th>';

        if ($_SESSION['SID_stufe2']==1) {
            echo '<th style="width: 10%;"><span>'.__('Manage').'</span></th>';
        }

        echo '<th style="width: 5%;"><span>'.__('Status').'</span></th>';
        echo '</tr></thead><tbody>';
        // }}}

        $query = "SELECT nr, article_nr, auth, autor, changer, commentary, freigabe, released_user_id, last_modify, pub_datum, sort_id, templates_id, titel, verfallsdatum "
                .$_q
                ."ORDER BY ".$cpoRubricSettings['sorting']." "
                ."LIMIT ".$_SESSION['SID_pagers']['articles'].", ".$cpoSystem['noOfArticles'];
        DEBUG(1, 'Artikel einlesen<br /><br />'.$query, __FILE__, __LINE__);
        $db->query($query);

        while($db->next_record()) {
            echo '<tr>';
            // article sorting {{{
            if ($_SESSION['SID_stufe2']==1 && $cpoRubricSettings['sorting']=='sort_id desc') { 
                echo '<td>';

                // Find article "below" this one {{{
                $query = "SELECT nr, sort_id FROM ".CPO_NEWS." "
                        ."WHERE artikel_archiv=0 "
                        ."AND sort_id<'".$db->v('sort_id')."' "
                        ."AND rubric_id='".$_SESSION['SID_rubric_id']."' "
                        ."ORDER BY sort_id DESC LIMIT 1";
                DEBUG(2, 'Find article "below" this one.<br /><br />'.$query, __FILE__, __LINE__);
                $db_2 = new DB;
                $db_2->query($query);
                $down_id = 'no';
                if ($db_2->num_rows()>0) {
                    $db_2->next_record();
                    $down_id = $db_2->v('sort_id');
                    $down_nr = $db_2->v('nr');
                }
                // }}}
                // Find article "above" this one {{{
                $query = "SELECT nr, sort_id FROM ".CPO_NEWS." "
                        ."WHERE artikel_archiv=0 "
                        ."AND sort_id>'".$db->v('sort_id')."' "
                        ."AND rubric_id='".$_SESSION['SID_rubric_id']."' "
                        ."ORDER BY sort_id LIMIT 1";
                DEBUG(2, 'Find article "above" this one.<br /><br />'.$query, __FILE__, __LINE__);
                $db_2->query($query);
                $up_id = 'no';
                if ($db_2->num_rows()>0) {
                    $db_2->next_record();
                    $up_id = $db_2->v('sort_id');
                    $up_nr = $db_2->v('nr');
                } 
                // }}}
                
                if ($up_id=='no') {
                    echo '<img style="margin-bottom: 2px;" src="'.SKIN_URL.'sort_empty'.($_GET['unr']==$db->v('nr')?'2':'').'.gif" width="13" height="13" alt="" /><br />';
                } else {
                    $art_pos = $_SESSION['SID_pagers']['articles'];
                    if ($art_count=='0') $art_pos = $_SESSION['SID_pagers']['articles'] - $cpoSystem['noOfArticles'];
                    echo '<a href="'.BASE_URL.'_admin/articles.php?action=articles_sort&pos='.$art_pos.'&unr='.$db->v('nr').'&switch_id='.$up_id.'&sort_id='.$db->v('sort_id').'&switch_nr='.$up_nr.'&sort_nr='.$db->v('nr').'">';
                    echo '<img style="margin-bottom: 2px;" src="'.SKIN_URL.'sort_up'.($_GET['unr']==$db->v('nr')?'2':'').'.gif" width="13" height="13" alt="'.__('move up').'" title="'.__('move up').'" />';
                    echo '</a><br />';
                }

                if ($down_id=='no') {
                    echo '<img style="margin-bottom: 2px;" src="'.SKIN_URL.'sort_empty'.($_GET['dnr']==$db->v('nr')?'2':'').'.gif" width="13" height="13" alt="" /><br />';
                } else {
                    $art_pos = $_SESSION['SID_pagers']['articles'];
                    if ($art_count==($cpoSystem['noOfArticles']-1) ) {
                        $art_pos = $_SESSION['SID_pagers']['articles'] + $cpoSystem['noOfArticles'];
                    }
                    echo '<a href="'.BASE_URL.'_admin/articles.php?action=articles_sort&pos='.$art_pos.'&dnr='.$db->v('nr').'&switch_id='.$down_id.'&sort_id='.$db->v('sort_id').'&switch_nr='.$down_nr.'&sort_nr='.$db->v('nr').'">';
                    echo '<img style="margin-bottom: 2px;" src="'.SKIN_URL.'sort_down'.($_GET['dnr']==$db->v('nr')?'2':'').'.gif" width="13" height="13" alt="'.__('move down').'" title="'.__('move down').'" />';
                    echo '</a><br />';
                }
                echo '</td>';
            }
            // }}}
            // Title/Author {{{
            echo '<td>';
            mini_title($db->v('freigabe'), $db->v('pub_datum'), $db->v('verfallsdatum'), $db->v('titel'), $db->v('autor'), $db->v('changer'), $db->v('nr'), $db->v('last_modify'));
            echo '</td>';
            // }}}
            // Manage {{{
			$article_block = false;

			echo '<td style="white-space: nowrap;">';

			$query = "SELECT name, user "
					."FROM ".CPO_BLOCK.", ".CPO_LOG_LOGIN.", ".CPO_USER." "
					."WHERE log_login_id = ".CPO_LOG_LOGIN.".id "
					."AND user_id=".CPO_USER.".id "
					."AND news_nr='".$db->v('nr')."' "; 
			DEBUG(2, 'Getting name of user who blocked this article.<br /><br />'.$query, __FILE__, __LINE__);
			$db_2 = new DB;
			$db_2->query($query);
			
			// blocked, copy
			if ($db_2->num_rows()>0) {   
				$db_2->next_record();
				$article_block = true;

                printIcon(
                    BASE_REL.$activeModules[$directory]['directory'].'/newsletter.php?action=articles_modify&nr'.(int)$db->v('nr'),
                    SKIN_URL.'pic_locked.gif',
                    htmlspecialchars(sprintf(__('Newsletter is being edited by %s.'), $db_2->v('name')), ENT_COMPAT, 'ISO-8859-15'),
                    true
                );
			} 

			// change (not blocked)
			if (!$article_block) {
                printIcon(
                    BASE_REL.$activeModules[$directory]['directory'].'/newsletter.php?action=articles_modify&nr='.(int)$db->v('nr'),
                    SKIN_URL.'pic_edit.gif',
                    htmlspecialchars(__('modify newsletter'), ENT_COMPAT, 'ISO-8859-15'),
                    true
                );
			}

			// copy
            printIcon(
                BASE_URL.$activeModules[$directory]['directory'].'/newsletter.php?action=articles_copy&nr='.(int)$db->v('nr'),
                SKIN_URL.'pic_copy.gif',
                htmlspecialchars(__('copy newsletter'), ENT_COMPAT, 'ISO-8859-15'),
                true
            );
			// delete
            if ($article_block) {
                printIcon(
                    BASE_REL.$activeModules[$directory]['directory'].'/newsletter.php?action=articles_delete&nr='.(int)$db->v('nr'),
                    SKIN_URL.'pic_del.gif',
                    sprintf(__('Newsletter is being edited by %s.'), htmlspecialchars($db_2->v('name'), ENT_COMPAT, 'ISO-8859-15')),
                    false
                );
            } else {
                printIcon(
                    BASE_REL.$activeModules[$directory]['directory'].'/newsletter.php?action=articles_delete&nr='.(int)$db->v('nr'),
                    SKIN_URL.'pic_del.gif',
                    __('delete newsletter'),
                    true
                );
            }
			// Version archive
			if ($_SESSION['SID_user']['admin']>ROLE_EDITOR) {
                    $db_2 = new DB;
                    $query = "SELECT COUNT(*) "
                            ."FROM ".CPO_NEWS." "
                            ."WHERE article_nr=".$db->v('nr');
                    $db_2->query($query);
                    $db_2->next_record();
                    if ($db_2->v('COUNT(*)')>1) {
                        printIcon(
                            BASE_REL.$activeModules[$directory]['directory'].'/newsletter.php?action=articles_versions&nr='.(int)$db->v('nr'),
                            SKIN_URL.'pic_version.gif',
                            sprintf(__('show all %d newsletter versions'), $db_2->v('COUNT(*)')),
                            true
                        );
                    } else {
                        printIcon(
                            BASE_REL.$activeModules[$directory]['directory'].'/newsletter.php?action=articles_versions&nr='.(int)$db->v('nr'),
                            SKIN_URL.'pic_version.gif',
                            __('This is the only newsletter version.'),
                            false
                        );
                    }
			}
			echo '&nbsp;&nbsp;';

			// Newsletter text preview
            printIcon(
                BASE_REL.$activeModules[$directory]['directory'].'/process.php?action=text_preview&nr='.(int)$db->v('nr'),
                NL_SKIN_URL.'pic_text.gif',
                __('preview text newsletter'),
                true
            );
			// Newsletter preview
			if ($activeModules[$directory]['text_only'] != "yes")  {
                printIcon(
                    BASE_REL.$activeModules[$directory]['directory'].'/process.php?action=preview&nr='.(int)$db->v('nr'),
                    NL_SKIN_URL.'pic_preview.gif',
                    __('preview HTML newsletter'),
                    true
                );
			}
			// Newsletter sending
			if ($db->v('freigabe') == 0 && $permission_sending == 1)  {
                printIcon(
                    BASE_REL.$activeModules[$directory]['directory'].'/process.php?action=send&nr='.(int)$db->v('nr'),
                    NL_SKIN_URL.'pic_letter.gif',
                    __('send newsletter'),
                    true
                );
			} else {
                printIcon(
                    BASE_REL.$activeModules[$directory]['directory'].'/process.php?action=send&nr='.(int)$db->v('nr'),
                    NL_SKIN_URL.'pic_letter.gif',
                    __('send newsletter'),
                    false
                );
			}
            echo '</td>';
            // }}}
            // Status {{{
            echo '<td style="white-space: nowrap;">';
            mini_status($db->v('nr'), $db->v('article_nr'), $db->v('freigabe'), $activeModules[$directory]['directory'].'/newsletter.php?action=articles_status'); // FIXME article_nr needed or can nr be used?
            echo '</td>';
            // }}}
            // Publication {{{
//            echo '<td style="white-space: nowrap;">';
//            mini_publication($db->v('pub_datum'), $db->v('verfallsdatum')); 
//            echo '</td>';
            // }}}
            // Info {{{
//            echo '<td>';
//            mini_info($db->v('templates_id'), $db->v('commentary'), $db->v('auth'));
//            echo '</td>';
            // }}}
            echo '</tr>';
            $art_count++;
        }

        echo '</tbody></table>';
        next_page($_SESSION['SID_pagers']['articles'], $max_data, $cpoSystem['noOfArticles'], 1, 'list=letters', BASE_URL.$activeModules[$directory]['directory'].'/newsletter.php');
        break;
        // }}}
    }
}
?>