<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Newsletter"				                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

=== Version 4.3e / January 2014 ===

*/

if (!defined('CPO')) exit;

if (is_dir(substr(CPO_BASEDIR.$activeModules[$directory]['directory'].'/skin/'.$CPO['skin'],0,-1))) define('NL_SKIN_URL', BASE_REL.$activeModules[$directory]['directory'].'/skin/'.$CPO['skin']);
else define('NL_SKIN_URL', BASE_REL.$activeModules[$directory]['directory'].'/skin/conpresso/'); // Fallback to conpresso

// Funktionen
include_once(CPO_BASEDIR.$directory.'/includes/newsletter_functions.inc.php');

$db = new DB;
$query = "SELECT article_nr, autor, auth, commentary, templates_id, titel, datum, verfallsdatum, pub_datum, freigabe, released_user_id, release_date, last_modify, changer, nr "
        ."FROM ".CPO_NEWS." "
        ."WHERE nr='".(int)$_GET['nr']."'";
$db->query($query);
$db->next_record();
$_REQUEST['title'] = $db->v('titel');

printPageHeader(
    __('Send newsletter'),
    __('This is the final step for sending your Newsletter').' "<b>'.htmlspecialchars($_REQUEST['title'], ENT_COMPAT, 'ISO-8859-15').'</b>"',
    modHelp('actions','newsletter'),
    true,
    'modules'
);

require(CPO_BASEDIR."_include/message.php");

if (license($activeModules[$directory]['lkey'],$activeModules[$directory]['mod_id']) != 1 &&
    license($activeModules[$directory]['lkey'],$activeModules[$directory]['mod_id']) != 3)  
    {
    $deactivated = ' disabled="disabled"';
    $deactivated_hint = '&nbsp;('.__('available in the commercial version').')';
}

// ******** SENDING THE NEWSLETTER ***************
echo '<form method="post" action="'.$_SERVER['PHP_SELF'].'" name="sending">';
echo '<input type="hidden" name="action" value="out">';
echo '<input type="hidden" name="title" value="'.$_REQUEST['title'].'">';
echo '<input type="hidden" name="nr" value="'.(int)$_REQUEST['nr'].'">';

// ranking
if ($activeModules[$directory]['use_ranking'] == 'yes')  {
    // table header {{{
    echo '<table class="colored" style="width: 100%;">';
    echo '<thead><tr>';
    echo '<th colspan="2"><span>'.__('Rank control').'</span></th>';
    echo '</tr></thead><tbody>';
    // }}}

    echo '<tr>';
        echo '<td colspan="2">';
        echo __('Your rank mode is:'). ' <b>'.__($activeModules[$directory]['ranking_mode']).'</b><br/>';
        switch ($activeModules[$directory]['ranking_mode'])  {
            case 'upcluster':
                echo __('The newsletter will be sent to recipients with a rank higher or equal to the chosen one.');
                break;
            case 'downcluster':
                echo __('The newsletter will be sent to recipients with a rank lower or equal to the chosen one.');
                break;
            case 'group':
                echo __('The newsletter will only be sent to recipients with a rank equal to the chosen one.');
                break;
        }
        echo '</td>';
    echo '</tr>';

    $query = "SELECT rank, count(id) AS rank_count FROM ".$dbPrefix."_mod_newsletter_adresses WHERE active = 1 AND newsletter='".$directory."' GROUP BY rank ORDER BY rank DESC";
    DEBUG(1, $query, __FILE__, __LINE__); 
    $db = new DB;
    $db->query($query);
    $last = 1;
    $total = 0;
    if ( $db->num_rows()>0 )  {
        while($db->next_record()):
            if ($last == $db->num_rows()) $checked = " checked";
            $total += $db->v('rank_count');
            echo '<tr>';
                echo '<td class="leftrow">';
                echo __('Rank')." ".$db->v('rank').":";
                echo '</td>';
                echo '<td class="rightrow">';
                echo '<input type="radio" name="cpoNewsletterRank" value="'.$db->v('rank').'"'.$checked.'> '.$db->v('rank_count')." ".__('Recipients');
//				if ($activeModules[$directory]['ranking_mode'] == 'cluster') echo " (".sprintf(__('%s recipients in total'),$total).")";
                echo '</td>';
            echo '</tr>';
            $last++;
        endwhile;
    }
    echo '</tbody></table>';
}

// display of categories
if ($activeModules[$directory]['use_categories'] == 'yes')  {
    // table header {{{
    echo '<table class="colored" style="width: 100%;">';
    echo '<thead><tr>';

    echo '<th><span>'.__('Combinations of categories').'</span></th>';

    echo '</tr></thead><tbody>';
    // }}}
    echo '<tr>';
        echo '<td>';
        echo __('These different compilations of newsletters are requested by your active customers:');
        echo '</td>';
    echo '</tr>';
    $query = "SELECT categories, count(id) AS id_count FROM ".$dbPrefix."_mod_newsletter_adresses WHERE active = 1 AND newsletter='".$directory."' GROUP BY categories ORDER BY categories ASC";
    DEBUG(1, $query, __FILE__, __LINE__); 
    $db = new DB;
    $db->query($query);
    if ( $db->num_rows()>0 )  {
        $n = 0;
        while($db->next_record()):
            echo '<tr>';
                echo '<td>';
                echo '<input type="checkbox" name="check_cat[]" id="cat'.$n.'" value="'.$db->v('categories').'" checked="checked" /><label for="cat'.$n.'">';
                echo '&nbsp;&nbsp;&nbsp;'.$db->v('id_count')." x ";
                echo $db->v('categories');
                echo '</label></td>';
            echo '</tr>';
            $n++;
        endwhile;
    }
    if ($activeModules[$directory]['use_ranking'] == 'yes')  {
        echo '<tr>';
            echo '<td>';
            echo __('This accumulation is independent from the chosen rank, so don\'t expect this list to be changed when choosing a rank.');
            echo '</td>';
        echo '</tr>';
    }
    echo '</tbody></table>';
}

// table header {{{
echo '<table class="colored" style="width: 100%;">';
echo '<thead><tr>';

echo '<th colspan="2"><span>'.__('Last chance for a preview').'</span></th>';

echo '</tr></thead><tbody>';
// }}}
echo '<tr>';
    echo '<td class="leftrow">';
    echo __('Preview:');
    echo '</td>';
    echo '<td class="rightrow">';
    echo '<a href="process.php?action=text_preview&nr='.$_REQUEST['nr'].'" target="_blank"><img src="'.NL_SKIN_URL.'pic_text.gif"> '.__('Text-Preview').'</a>';
    if ($activeModules[$directory]['text_only'] != "yes")  {
        echo '&nbsp;&nbsp;&nbsp;<a href="process.php?action=preview&nr='.$_REQUEST['nr'].'" target="_blank"><img src="'.NL_SKIN_URL.'pic_preview.gif"> '.__('HTML-Preview').'</a>';
    }
    echo '</td>';
echo '</tr>';

echo '</tbody></table>';

// table header {{{
echo '<table class="colored" style="width: 100%;">';
echo '<thead><tr>';

echo '<th colspan="2"><span>'.__('Sending the newsletter').'</span></th>';

echo '</tr></thead><tbody>';
// }}}

echo '<tr>';
    echo '<td class="leftrow">';
    echo __('Scheduling newsletter job:');
    echo '</td>';
    echo '<td class="rightrow">';
    echo '<input type="checkbox" name="schedule" value="out"'.$deactivated.'> '.__('save as scheduled job only').$deactivated_hint;
    echo '<br /><input type="text" class="text inputwidth" name="schedule_name" value="'.$_REQUEST['title'].'/'.date("Y-m-d").'"'.$deactivated.'>';
    echo '</td>';
echo '</tr>';
echo '<tr>';
    echo '<td class="leftrow">';
    echo __('Sending newsletter').'<br />"<em>'.htmlspecialchars($_REQUEST['title'], ENT_COMPAT, 'ISO-8859-15').'</em>" &raquo; ';
    echo '</td>';
    echo '<td class="rightrow">';
    echo '<input type="submit" class="button" value="'.__('Send newsletter now').'">';
    echo '&nbsp;<input type="checkbox" name="cronjob" value="out"'.$deactivated.'> '.__('save as cronjob only').$deactivated_hint;
    echo '</td>';
echo '</tr>';
echo '</tbody></table>';

echo '</form>';

// Test-Newsletter senden
echo '<form method="post" action="'.$_SERVER['PHP_SELF'].'" name="rehearsalform">';
echo '<input type="hidden" name="action" value="out">';
echo '<input type="hidden" name="title" value="'.$_REQUEST['title'].'">';
echo '<input type="hidden" name="nr" value="'.(int)$_REQUEST['nr'].'">';
// table header {{{
echo '<table class="colored" style="width: 100%;">';
echo '<thead><tr>';

echo '<th colspan="2"><span>'.__('Newsletter rehearsal').'</span></th>';

echo '</tr></thead><tbody>';
// }}}

echo '<tr>';
    echo '<td class="leftrow">';
    echo __('Newsletter rehearsal').'<br /><em>"'.htmlspecialchars($_REQUEST['title'], ENT_COMPAT, 'ISO-8859-15').'</em>" &raquo; ';
    echo '</td>';
    echo '<td class="rightrow">';
    echo '<input type="text" name="rehearsal" value="'.$activeModules[$directory]['rehearsal'].'">';
    echo '&nbsp;<input type="submit" class="button" value="'.__('Newsletter rehearsal').'">';
    echo '</td>';
echo '</tr>';
echo '</tbody></table>';

echo '</form>';


?>