<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Newsletter"				                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

=== Version 4.3e / January 2014 ===

*/

$translator->addTranslation('articles');

// use rubric_id from session
if (isset($_SESSION['SID_rubric_id'])) {
    $cpoRubric['id'] = $_SESSION['SID_rubric_id'];
}
require(CPO_BASEDIR.'_include/var_category.php');
require(CPO_BASEDIR.'_include/check.php');

$views = array('list');

// include statt Originalcode
include(CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/article_actions.inc.php');

while ($nextview = array_shift($views)) {
    switch ($nextview) {
    case 'list': // {{{  ******************************** die Liste ****************************************
        require(CPO_BASEDIR.'_include/header.php');

		include(CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/inc_letters.inc.php');
    
        require(CPO_BASEDIR.'_include/footer.php');
        break;
        // }}}
    case 'list_release': // {{{  ********************************* Release-Tabelle **************************************
        $db = new DB;
        $query = "SELECT COUNT(*) FROM ".CPO_NEWS.", ".CPO_PERMISSION." "
                ."WHERE ".CPO_NEWS.".rubric_id=".CPO_PERMISSION.".rubric_id "
                ."AND artikel_archiv='0' "
                ."AND freigabe>'".STATE_RELEASED."' "
                ."AND stufe4='1' "
                ."AND user_id='".addslashes($_SESSION['SID_user']['id'])."'";
        DEBUG(2, $query, __FILE__, __LINE__);
        $db->query($query);
        $db->next_record();
        $max_data = $db->v('COUNT(*)');

        if (isset($_GET['pos'])) $_SESSION['SID_pagers']['articles_release'] = $_GET['pos'];

        if ($max_data<=$_SESSION['SID_pagers']['articles_release'])
            $_SESSION['SID_pagers']['articles_release'] = $max_data-1;
        if (!isset($_SESSION['SID_pagers']['articles_release']) 
            || $_SESSION['SID_pagers']['articles_release']<0)
            $_SESSION['SID_pagers']['articles_release'] = 0;

        require(CPO_BASEDIR.'_include/header.php');
        printPageHeader(
            __('Release newsletters'),
            __('Please choose the newsletter that is supposed to be changed.'),
			modHelp('actions','newsletter'),
			true,
			'modules'
        );
        if ($max_data<=0) {
            $message[] = __('No newsletter within your release area were found.');
            include(CPO_BASEDIR.'_include/message.php');
            include(CPO_BASEDIR.'_include/footer.php');
            break;
        }
        include(CPO_BASEDIR.'_include/message.php');

        $query = "SELECT nr, name, templates_id, sort_id, ".CPO_NEWS.".rubric_id, commentary, auth, freigabe, article_nr, titel, autor, ".CPO_NEWS.".changer, last_modify, pub_datum, verfallsdatum, stufe4 "
                ."FROM ".CPO_NEWS.", ".CPO_PERMISSION.", ".CPO_RUBRIC." "
                ."WHERE ".CPO_NEWS.".rubric_id=".CPO_PERMISSION.".rubric_id "
                ."AND ".CPO_NEWS.".rubric_id=".CPO_RUBRIC.".id "
                ."AND artikel_archiv=0 "
                ."AND freigabe>'".STATE_RELEASED."' "
                ."AND stufe4='1' "
                ."AND user_id='".$_SESSION['SID_user']['id']."'"
                ."ORDER BY name, datum " // FIXME sort by?
                ."LIMIT ".$_SESSION['SID_pagers']['articles_release'].",".$cpoSystem['noOfArticles'];
        DEBUG(2, $query, __FILE__, __LINE__);
        $db->query($query);
            
        echo '<table class="ruler" style="width: 100%">';
        echo '<thead><tr>';

        echo '<th style="width: 50%;"><span>'.__('Title/Author').'</span></th>';
        echo '<th style="width: 20%;"><span>'.__('Rubric').'</span></th>';
        echo '<th style="width: 10%;"><span>'.__('Status').'</span></th>';
        echo '<th style="width: 15%;"><span>'.__('Publication').'</span></th>';
        echo '<th style="width: 5%;"><span>'.__('Info').'</span></th>';
        echo '</tr></thead><tbody>';

        while($db->next_record()) {
            echo '<td>';
            mini_title($db->v('freigabe'), $db->v('pub_datum'), $db->v('verfallsdatum'), $db->v('titel'), $db->v('autor'), $db->v('changer'), $db->v('nr'), $db->v('last_modify'));
            echo '</td>';

            echo '<td>';
            echo '<a href="'.BASE_REL.'_admin/index.php?rubric='.htmlspecialchars($db->v('rubric_id'), ENT_COMPAT, 'ISO-8859-15').'" target="_top"><b><nobr>'.htmlspecialchars($db->v('name'), ENT_COMPAT, 'ISO-8859-15').'</nobr></b></a><br />';
            echo '</td>';

            echo '<td>';
            mini_status($db->v('nr'), $db->v('article_nr'), $db->v('freigabe'), $activeModules[$directory]['directory'].'/newsletter.php?action=articles_status_release', $db->v('stufe4'));
            echo '</td>';

            echo '<td>';
            mini_publication($db->v('pub_datum'), $db->v('verfallsdatum'));
            echo '</td>';

            echo '<td>';
            $query = "SELECT name FROM ".CPO_TEMPLATES." " // FIXME do not run for each article entry...
                    ."WHERE id='".$db->v('templates_id')."'";
            DEBUG(2, $query, __FILE__, __LINE__);
            $db2 = new DB;
            $db2->query($query);
            $template_name = '';
            while ($db2->next_record()) { // usually runs only once
                $template_name = $db2->v("name");
            }
            print('<img align="absmiddle" src="'.SKIN_URL.'sym_template.gif" '
                .'alt="'  .htmlspecialchars(sprintf(__('Article-template: %s'), $template_name), ENT_COMPAT, 'ISO-8859-15').'" '
                .'title="'.htmlspecialchars(sprintf(__('Article-template: %s'), $template_name), ENT_COMPAT, 'ISO-8859-15').'" width="13" height="13" >&nbsp;');

            if ($db->v('commentary')!='') {
                print ('<img align="absmiddle" src="'.SKIN_URL.'sym_comment.gif" alt="'.htmlspecialchars($db->v('commentary'), ENT_COMPAT, 'ISO-8859-15').'" title="'.htmlspecialchars($db->v('commentary'), ENT_COMPAT, 'ISO-8859-15').'" width="13" height="13" >&nbsp;');
            } else {
                print ('<img align="absmiddle" src="../_images/transparent.gif" alt="" width="13" height="13" >&nbsp;');
            }

            if ($db->v('auth')!='') {
                $auth_text = $db->v('auth');
                $auth_text = ereg_replace ( "#", ", ", $auth_text);
                $auth_text = substr($auth_text, 2);
                $auth_text = substr($auth_text, 0, -2);
                print ('<img align="absmiddle" src="'.SKIN_URL.'sym_pers.gif" '
                    .'alt="'  .htmlspecialchars(sprintf(__('personalized article: %s'), $auth_text), ENT_COMPAT, 'ISO-8859-15').'" '
                    .'title="'.htmlspecialchars(sprintf(__('personalized article: %s'), $auth_text), ENT_COMPAT, 'ISO-8859-15').'" width="13" height="13" >');
            } else {
                print ('<img align="absmiddle" src="../_images/transparent.gif" alt="" width="13" height="13" >');
            }

            echo '</td>';

            echo '</tr>';
        }
            
        echo '</tbody></table>';
        next_page($_SESSION['SID_pagers']['articles_release'], $max_data, $cpoSystem['noOfArticles'], true, 'action=articles_release');
        require(CPO_BASEDIR.'_include/footer.php');
        break; // }}}
    case 'list_versions': // {{{  ******************************** Versions-Liste ********************************
        require(CPO_BASEDIR.'_include/header.php');

        $db = new DB;
        $query = "SELECT article_nr, autor, auth, commentary, templates_id, titel, datum, verfallsdatum, pub_datum, freigabe, released_user_id, release_date, last_modify, changer, nr "
                ."FROM ".CPO_NEWS." "
                ."WHERE nr='".(int)$_POST['nr']."'";
        $db->query($query);
        $db->next_record();

        printPageHeader(
            __('Newsletter versions'), 
            sprintf(__('Here you can administrate the versions of newsletter %s.'), '<em>'.htmlspecialchars($db->v('titel'), ENT_COMPAT, 'ISO-8859-15').'</em>'),
			modHelp('actions','newsletter'),
			true,
			'modules'
        );
        include(CPO_BASEDIR.'_include/message.php');

        echo '<table class="ruler" style="width: 100%"><thead><tr>';
        echo '<th style="width: 20%;"><span>'.__('Version date').'</span></th>';
        echo '<th style="width:  5%;"><span>'.__('Manage')      .'</span></th>';
        echo '<th style="width: 50%;"><span>'.__('Title/Author').'</span></th>';
        echo '<th style="width: 10%;"><span>'.__('Status')      .'</span></th>';
        echo '<th style="width: 10%;"><span>'.__('Publication') .'</span></th>';
        echo '<th style="width:  5%;"><span>'.__('Info')        .'</span></th>';
        echo '</tr></thead><tbody>';
    
        // actual article {{{
        $article_nr = $db->v('article_nr'); // used to display versions below

        // is the newest version the online one?
        $online = false;
        $trclass = '';
        if ($db->v('artikel_archiv')==0 && $db->v('freigabe')==STATE_RELEASED) { 
            $trclass = 'table_system_active';
            $online = true;
        }

        print('<tr class="'.$trclass.'">');
        ?>
        <td style="white-space: nowrap;">
            <?php
            // Version date
            print($db->v('last_modify')>0 ? 
                date($cpoSystem['date_format'], strtotime($db->v('last_modify'))) : 
                date($cpoSystem['date_format'], strtotime($db->v('datum')))
            );
            print('<br />');

            if ($db->v('freigabe')==STATE_RELEASED) {
                print(date($cpoSystem['date_format'], strtotime($db->v('release_date'))));
                // FIXME display released_user_id name if ($freigabe_name!=$changer && $freigabe_name!='') {
            }
            ?>
        </td>

        <td> <!-- manage --></td>

        <?php
        echo '<td>';
        $r = $db->v('freigabe');
        if (!$online) $r = -1; // do not display the published image for versions not online
        mini_title($r, $db->v('pub_datum'), $db->v('verfallsdatum'), $db->v('titel'), $db->v('autor'), $db->v('changer'), $_POST['nr'], $db->v('last_modify'));
        echo '</td>';

        echo '<td style="white-space: nowrap;">';
        mini_status($_POST['nr'], $db->v('article_nr'), $db->v('freigabe'), $activeModules[$directory]['directory'].'/newsletter.php?action=articles_status_versions');
        echo '</td>';

        echo '<td>';
        mini_publication($db->v('pub_datum'), $db->v('verfallsdatum')); 
        echo '</td>';

        echo '<td>';
        mini_info($db->v('templates_id'), $db->v('commentary'), $db->v('auth'));
        echo '</td>';

        echo '</tr>';
        // }}}
        // article revisions {{{
        $query = "SELECT nr, artikel_archiv, article_nr, auth, commentary, rubric_id, templates_id, titel, datum, verfallsdatum, pub_datum, freigabe, released_user_id, release_date, autor, last_modify, changer "
                ."FROM ".CPO_NEWS." "
                ."WHERE artikel_archiv!=0 " // exclude the actual 
                ."AND article_nr='".(int)$article_nr."' "
                ."ORDER BY last_modify DESC";
        $db->query($query);
        if ($db->num_rows()<=0) {
            print('</tbody></table>');
            require(CPO_BASEDIR.'_include/footer.php');
            continue;
        }

        while($db->next_record()) {
            $trclass = '';
            if (!$online && $db->v('artikel_archiv')==1) {
                $trclass = 'table_system_active';
                $online = true;
            }
            print('<tr class="'.$trclass.'">');
            echo '<td>';
            // Version date
            print($db->v('last_modify')>0 ? 
                date($cpoSystem['date_format'], strtotime($db->v('last_modify'))) : 
                date($cpoSystem['date_format'], strtotime($db->v('datum')))
            );
            print('<br />');

            if ($db->v('freigabe')==STATE_RELEASED) {
                print(date($cpoSystem['date_format'], strtotime($db->v('release_date'))));
                // FIXME display released_user_id name if ($freigabe_name!=$changer && $freigabe_name!='') {
            }
            echo '</td>';

            echo '<td>';
            print('<a href="'.BASE_REL.$activeModules[$directory]['directory'].'/newsletter.php?action=articles_versions_restore&amp;nr='.$_POST['nr'].'&amp;version_nr='.$db->v('nr').'">');
            print('<img src="'.SKIN_URL.'pic_restore.gif" class="pic_" alt="'.___('restore newsletter version').'" title="'.___('restore newsletter version').'" />');
            print('</a>');
            if ($db->v('artikel_archiv')!=1) {
                print('<a href="'.BASE_REL.$activeModules[$directory]['directory'].'/newsletter.php?action=articles_versions_delete&amp;nr='.$db->v('nr').'">');
                print('<img src="'.SKIN_URL.'pic_del.gif" class="pic_" alt="'.___('delete newsletter version').'" title="'.___('delete newsletter version').'" />');
                print('</a>');
            }
            echo '</td>';

            echo '<td>';
            $r = $db->v('freigabe');
            if (empty($trclass)) $r = -1; // do not display the published image for versions not online
            mini_title($r, $db->v('pub_datum'), $db->v('verfallsdatum'), $db->v('titel'), $db->v('autor'), $db->v('changer'), $_POST['nr'], $db->v('last_modify'));
            echo '</td>';

            echo '<td>';
            mini_status($db->v('nr'), $db->v('article_nr'), $db->v('freigabe'), $activeModules[$directory]['directory'].'/newsletter.php?action=articles_status&amp;info=1');
            echo '</td>';

            echo '<td>';
            mini_publication($db->v('pub_datum'), $db->v('verfallsdatum'));
            echo '</td>';

            echo '<td>';
            mini_info($db->v('templates_id'), $db->v('commentary'), $db->v('auth'));
            echo '</td>';

            echo '</tr>';
        } 
        echo '</tbody></table>';
        // }}}
        include(CPO_BASEDIR.'_include/footer.php');
        break; // }}}
    case 'edit_form': // {{{  **************************** Das Editier-Formular **********************************

        require(CPO_BASEDIR.'_include/header.php');

        if (empty($_POST['nr'])) {
            if (empty($_POST['copy'])) {
                printPageHeader(
                    __('Create newsletter'),
                    __('Here you can create a newsletter.'),
					modHelp('actions','newsletter'),
					true,
					'modules'
                );
            } else {
                printPageHeader(
                    __('Copy newsletter'),
                    __('Please change the data of the copied newsletter below.'),
					modHelp('actions','newsletter'),
					true,
					'modules'
                );
            }
        } else {
            printPageHeader(
                __('Edit newsletter'),
                sprintf(__('Here you can modify the newsletter %s.'), '<em>'.htmlspecialchars($_POST['titel'], ENT_COMPAT, 'ISO-8859-15').'</em>'),
				modHelp('actions','newsletter'),
				true,
				'modules'
            );
        }
        include(CPO_BASEDIR.'_include/message.php');

        $query = "SELECT COUNT(*) "
                ."FROM ".CPO_TPL_ASSIGNMENT.", ".CPO_TEMPLATES." "
                ."WHERE templates_id=".CPO_TEMPLATES.".id "
                ."AND ".CPO_TPL_ASSIGNMENT.".rubric_id = '".$_SESSION['SID_rubric_source_rubric_id']."'";
        $db = new DB;
        $db->query($query);
        $db->next_record();
        if ($db->v('COUNT(*)')<=0) {
            $message[] = __('No article-templates are assigned to this rubric.').'<br />';
            if ($_SESSION['SID_user']['admin']>=ROLE_SUPERUSER) {
                $message[] = sprintf(__('Please do so in the %srubric settings%s.'),
                    '<a href="'.BASE_REL.'_admin/rubrics.php?action=rubrics_showsettings&id='.(int)$_SESSION['SID_rubric_source_rubric_id'].'">',
                    '</a>'
                );
            }
            include(CPO_BASEDIR.'_include/message.php');
            include(CPO_BASEDIR.'_include/footer.php');
            break;
        }

        print('<form method="post" action="'.$_SERVER['PHP_SELF'].'" onsubmit="return innerToHidden();" name="article_form">');
        print('<input type="hidden" name="action" value="articles_save">');
        // FIXME use print to print the complete tags... ?>
        <input type="hidden" name="nr"       value="<?php echo (int)$_POST['nr'];       ?>">
        <input type="hidden" name="auth"     value="<?php echo $_POST['auth'];     ?>">
        <input type="hidden" name="sort_id"  value="<?php echo $_POST['sort_id'];  ?>">
        <input type="hidden" name="freigabe" value="<?php echo $_POST['freigabe']; ?>">
        <input type="hidden" name="copy"     value="<?php echo $_POST['copy'];     ?>">

        <?php
        require(CPO_BASEDIR.'_include/article_form.php'); // FIXME Display the content table if no placeholders are use?

        print('</form>');
        include(CPO_BASEDIR.'_include/footer.php');

        break;
        // }}}
    case 'move': // {{{  ************************** Verschieben von Newslettern ************************* wird eigentlich nicht bentigt, oder? => gelscht!
    case 'reject': // {{{ reject_versions, reject_release  ***************************** Reject *******************************
    case 'reject_versions':
    case 'reject_release':
        require(CPO_BASEDIR.'_include/header.php');

        printPageHeader(
            __('Reject newsletter'),
            sprintf(__('You are going to reject the newsletter %s. You should probably send the author of the newsletter (%s <%s>) a message why you rejected his content.'), 
                '<em>'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'</em>',
                '<em>'.htmlspecialchars($autor, ENT_COMPAT, 'ISO-8859-15').'</em>',
                '<em>'.htmlspecialchars($email, ENT_COMPAT, 'ISO-8859-15').'</em>'
            ),
			modHelp('actions','newsletter'),
			true,
			'modules'
        );
        include(CPO_BASEDIR.'_include/message.php');

        // do we have template candidates?
        echo '<form method="post" action="'.$_SERVER['PHP_SELF'].'" onsubmit="return innerToHidden();" name="article_form">';
        switch ($nextview) {
        case 'reject';
            echo '<input type="hidden" name="action" value="articles_status">';
            break;
        case 'reject_versions';
            echo '<input type="hidden" name="action" value="articles_status_versions">';
            break;
        case 'reject_release';
            echo '<input type="hidden" name="action" value="articles_status_release">';
            break;
        }
        echo '<input type="hidden" name="sendmessage" value="1">';
        echo '<input type="hidden" name="nr" value="'.(int)$_REQUEST['nr'].'" />';
        echo '<input type="hidden" name="status" value="'.STATE_REJECTED.'" />';
        echo '<table class="colored" style="width: 100%;"><thead>';
        echo '<tr><th colspan="2"><span>'.__('Rejection reason').'</span></th></tr>';
        echo '</thead><tbody>';
        echo '<tr><td>'.__('Subject:').'</td><td>';
        echo '<input type="text" class="text inputwidth" name="subject" value="'.__('Article rejected').'" />';
        echo '</td></tr>';
        echo '<tr><td>'.__('Message:').'</td><td>';
        echo '<textarea class="textarea" cols="80" rows="20" name="body">';
        echo sprintf(__("------------------------------------------------------------------------\nThis e-mail was automatically generated. If you have questions please\ncontact your administrator <%s>.\n------------------------------------------------------------------------\n\nHello %s,\n\none of your articles was rejected:\n\nProject:     %s\nRubric:      %s\nTitle:       %s\n\nResponsible: %s <%s>\n\nReason:\n"),
            htmlspecialchars($cpoSystem['admin_email'], ENT_COMPAT, 'ISO-8859-15'), // admin
            htmlspecialchars($autor, ENT_COMPAT, 'ISO-8859-15'), // user
            htmlspecialchars($cpoSystem['project'], ENT_COMPAT, 'ISO-8859-15'), // project
            htmlspecialchars($rubric, ENT_COMPAT, 'ISO-8859-15'), // Rubric
            htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15'), // Title
            htmlspecialchars($_SESSION['SID_user']['name'], ENT_COMPAT, 'ISO-8859-15'), // responsible
            htmlspecialchars($_SESSION['SID_user']['email'], ENT_COMPAT, 'ISO-8859-15') // responsible
        );
        echo '</textarea>';
        echo '</td></tr>';
        echo '<tr><td>&nbsp;</td><td>';
        echo '<input type="submit" name="sendmessageyes" value="'.__('send message').'" />';
        echo '<input type="submit" name="sendmessageno" value="'.__('don\'t send message').'" />';
        echo '</td></tr>';
        echo '</tbody></table>';
        print('</form>');
        include(CPO_BASEDIR.'_include/footer.php');

        break;
        // }}}
    case 'reallydelete': // {{{  *********************** Lschen ***********************************************
        require(CPO_BASEDIR.'_include/header.php');

        printPageHeader(
            __('Delete newsletter'),
            sprintf(__('You are going to delete the newsletter %s.'), '<em>'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'</em>'),
			modHelp('actions','newsletter'),
			true,
			'modules'
        );
        include(CPO_BASEDIR.'_include/message.php');

        $message .= sprintf(__('Are you really sure you want to delete the newsletter %s?'), 
            '<em>'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'</em>'
        );

        $message .= '<form method="post" action="'.$_SERVER['PHP_SELF'].'">';
        $message .= '<input type="hidden" name="action" value="articles_delete_really">';
        $message .= '<input type="hidden" name="nr" value="'.(int)$_GET['nr'].'" />';
        $message .= '<input type="submit" name="yes" value="'.__('Yes, delete').'" />&nbsp;';
        $message .= '<input type="submit" name="no" value="'.__('No, do not delete').'" />';
        $message .= '</form>';
        if(file_exists(CPO_BASEDIR.'_include/confirmation.php')) include(CPO_BASEDIR.'_include/confirmation.php');
        else include(CPO_BASEDIR.'_include/message.php');
        include(CPO_BASEDIR.'_include/footer.php');

        break;
        // }}}
    }
}

?>