<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Newsletter"				                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

=== Version 4.3e / January 2014 ===

*/

if (!defined('CPO')) exit;

// Newsletter-Funktionen
function is_email_valid($email) {
	global $activeModules,$directory;
	if ($GLOBALS['page_name'] == 'cpoPageNewsletterMiniForm') $directory=str_replace(array(';',' ','/'),'',$GLOBALS['_params']); // Workaround fr PageTemplateFunction!
	if ($activeModules[$directory]['mail_check'] == "yes" && $activeModules[$directory]['regexp'])  {
		if ($activeModules[$directory]['dns_check'] == "yes")  {
            $mx = explode("@",$email);
			if (ereg($activeModules[$directory]['regexp'], trim($email)) && checkdnsrr($mx[1],"MX") && checkdnsrr($mx[1],"NS")) 
				return TRUE; 
			return FALSE; 
		} elseif ($activeModules[$directory]['dns_check'] == "no" && $activeModules[$directory]['regexp']) {
			if (ereg($activeModules[$directory]['regexp'], trim($email))) 
				return TRUE; 
			return FALSE; 
		}
	}
	return TRUE;
}

function qp_encoding($Message) {
    /* Taken from the php.net documentation */
    /* Build (most polpular) Extended ASCII Char/Hex MAP (characters >127 & <255) */
    for ($i=0; $i<127; $i++) {
        $CharList[$i] = "/".chr($i+128)."/";
        $HexList[$i] = "=".strtoupper(bin2hex(chr($i+128)));
    }

    /* Encode equal sign & 8-bit characters as equal signs followed by their hexadecimal values */
    $Message = str_replace("=", "=3D", $Message);
    $Message = preg_replace($CharList, $HexList, $Message);

    /* Lines longer than 76 characters (size limit for quoted-printable Content-Transfer-Encoding)
        will be cut after character 75 and an equals sign is appended to these lines. */ 
    $MessageLines = split("\n", $Message);
    $Message_qp = "";
    while(list(, $Line) = each($MessageLines)) {
        if (strlen($Line) > 75) {
            $Pointer = 0;        
            while ($Pointer <= strlen($Line)) {
                $Offset = 0;
                if (preg_match("/^=(3D|([8-9A-F]{1}[0-9A-F]{1}))$/", substr($Line, ($Pointer+73), 3))) $Offset=-2;
                if (preg_match("/^=(3D|([8-9A-F]{1}[0-9A-F]{1}))$/", substr($Line, ($Pointer+74), 3))) $Offset=-1;
                $Message_qp.= substr($Line, $Pointer, (75+$Offset))."=\n";
                if ((strlen($Line) - ($Pointer+75)) <= 75) {                
                    $Message_qp.= substr($Line, ($Pointer+75+$Offset))."\n";
                    break 1;
                }
                $Pointer+= 75+$Offset;
            }
        } else {
            $Message_qp.= $Line."\n";
        }
    }
    return ereg_replace(chr(13),"",$Message_qp);
}

function newsletter_receiver_up($nr)  {
	global $dbPrefix;
	$query = "UPDATE ".$dbPrefix."_mod_newsletter_adresses SET rank=rank+1 WHERE id = '".(int)$nr."'";
	DEBUG(1, $query, __FILE__, __LINE__);
	$db = new DB;
	$db->query($query);
}

function newsletter_receiver_down($nr)  {
	global $dbPrefix;
	$query = "UPDATE ".$dbPrefix."_mod_newsletter_adresses SET rank=rank-1 WHERE rank>0 AND id = '".(int)$nr."'";
	DEBUG(1, $query, __FILE__, __LINE__);
	$db = new DB;
	$db->query($query);
}

function newsletter_receiver_activate($nr,$hash)  {
	global $dbPrefix;
	$query = "UPDATE ".$dbPrefix."_mod_newsletter_adresses SET active=1 WHERE (id = '".(int)$nr."' AND hash = '".addslashes($hash)."')";
	DEBUG(1, $query, __FILE__, __LINE__);
	$db = new DB;
	$db->query($query);
}

function newsletter_receiver_deactivate($nr,$hash)  {
	global $dbPrefix;
	$query = "UPDATE ".$dbPrefix."_mod_newsletter_adresses SET active=0 WHERE (id = '".(int)$nr."' AND hash = '".addslashes($hash)."')";
	DEBUG(1, $query, __FILE__, __LINE__);
	$db = new DB;
	$db->query($query);
}

function newsletter_receiver_ban($nr,$hash)  {
	global $dbPrefix;
	$query = "UPDATE ".$dbPrefix."_mod_newsletter_adresses SET active=2 WHERE (id = '".(int)$nr."' AND hash = '".addslashes($hash)."')";
	DEBUG(1, $query, __FILE__, __LINE__);
	$db = new DB;
	$db->query($query);
}

function newsletter_receiver_delete($nr,$hash)  {
	global $dbPrefix;
	$query = "DELETE FROM ".$dbPrefix."_mod_newsletter_adresses WHERE id = '".(int)$nr."'";
	DEBUG(1, $query, __FILE__, __LINE__);
	$db = new DB;
	$db->query($query);
}

function newsletter_receiver_unscribe($hash)  {
	global $dbPrefix;
	$query = "DELETE FROM ".$dbPrefix."_mod_newsletter_adresses WHERE hash = '".addslashes($hash)."'";
	DEBUG(1, $query, __FILE__, __LINE__);
	$db = new DB;
	$db->query($query);
}

function array_search_bit($search, $array_in)  {
   foreach ($array_in as $key => $value)  {
	   if (strpos($value, $search) !== FALSE)
	   return $key;
   }
   return FALSE;
}

function array_search_recursive( $needle, $haystack )
{
   $path = NULL;
   $keys = array_keys($haystack);
   while (!$path && (list($toss,$k)=each($keys))) {
     $v = $haystack[$k];
     if (is_scalar($v)) {
         if ($v===$needle) {
           $path = array($k);
         }
     } elseif (is_array($v)) {
         if ($path=array_search_recursive( $needle, $v )) {
           array_unshift($path,$k);
         }
     }
   }
   return $path;
}

function check_receiver($email)  {
// prft ob es einen Emfnger bereits gibt und gibt seinen Status zurck
	global $dbPrefix,$directory;
	$query = "SELECT active FROM ".$dbPrefix."_mod_newsletter_adresses WHERE email = '".addslashes($email)."' AND newsletter='".$directory."'";
	DEBUG(1, $query, __FILE__, __LINE__);
	$db = new DB;
	$db->query($query);
	if ( $db->num_rows()>0 )  {
		$db->next_record();
		return $db->v('active');
	} else {
		return FALSE;
	}
}

function staggered_process($act, $total)  {
	// Fortschrittsanzeige
	$filled = (int) (($act/$total)*100);
	$unfilled = (int) (($total-$act)*100);
	echo '<table width="100%" border="0" cellspacing="0" cellpadding="0"><tr><td width="5%">';
	echo "0%&nbsp;&nbsp;";
	echo '</td><td width="90%">';
	echo '<table width="100%" border="0" cellspacing="0" cellpadding="0"><tr>';
	echo '<td width="'.$filled.'%" bgcolor="#ffa800" style="text-align: right;"><font color="#FFFFFF">&nbsp;<b>'.$filled.'%</b>&nbsp;</font></td>';
	echo '<td width="'.$unfilled.'%">&nbsp;</td>';
	echo '</tr></table>';
	echo '</td><td width="5%">';
	echo "&nbsp;&nbsp;100%";
	echo '</td></tr></table>';
}

if (!function_exists('boxHeader'))  {
	function boxHeader($name, $text, $display)  {
		// the initial setting
		if ($display === false)  {
			$visibility = ' style="display:none"';
			$linkText = __('show');
		} else {
			$visibility = '';
			$linkText = __('hide');
		}
		// override with the chosen setting
		if ($_COOKIE[$name] == 'false')  {
			$visibility = ' style="display:none"';
			$linkText = __('show');
		} else if ($_COOKIE[$name] == 'true') {
			$visibility = '';
			$linkText = __('hide');
		}
		echo '<table class="colored" style="width: 100%;"><thead><tr><th><span><a href="#" onClick="ausblenden(\''.$name.'\', \''.$name.'link\');return false">' . $text . '</a></span></th><th style="text-align:right !important;"><span><a href="#" onClick="ausblenden(\''.$name.'\',\''.$name.'link\');return false" id="'.$name.'link">'.$linkText.'</a></span></th></tr></thead><tbody id="'.$name.'"'.$visibility.'>';
	}
}

if (!function_exists('modHelp'))  {
	function modHelp($topic,$module)  {
		return 'http://manual.conpresso4.de/'.$module.'/'.$topic.".htm";
	}
}

if (!function_exists('newsletterPlaceholder'))  {
	function newsletterPlaceholder($placeholder)  {
		return '/(<|\[)!--(\s|&nbsp;)*'.preg_quote($placeholder,'/').'(\s|&nbsp;)*--(>|\])/si';
	}
}

if (!function_exists('decode_entities'))  {
    function decode_entities($text) {
         $text= html_entity_decode($text,ENT_QUOTES,"ISO-8859-15"); #once
         $text= html_entity_decode($text,ENT_QUOTES,"ISO-8859-15"); #twice
         $text= preg_replace('/&#(\d+);/me',"chr(\\1)",$text); #decimal notation
         $text= preg_replace('/&#x([a-f0-9]+);/mei',"chr(0x\\1)",$text);  #hex notation
         $text= str_replace("\r\n","\n",$text);
         return $text;
    }
}
?>