<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Newsletter"				                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

=== Version 4.3e / January 2014 ===

*/

define('CPO', true);
require_once('../_include/checkaccess.inc.php');
include(CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/producer.inc.php');

// Sprache
$directory = basename(dirname($_SERVER['PHP_SELF'])); 
$translator->addTranslation('newsletter',CPO_BASEDIR.$directory.'/lang');

// Modulbilder
require(CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/modul_pics.inc.php'); // FIX ME Was ist das?

// Aktionen
include(CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/actions.inc.php');

if (!license($activeModules[$directory]['lkey'],$activeModules[$directory]['mod_id']) && $activeModules[$directory]['installed']<(time()-90*24*60*60)) {
	$message['license'] = '<strong>'.sprintf(___('Your 90 days %s evaluation period has expired!'),
		htmlspecialchars($CPO['product'], ENT_COMPAT, 'ISO-8859-15')).'</strong> ';
	$message['license'] .= sprintf(___('This is a fully functional, but not registered version of %1$s. Please contact your %2$sadministrator%3$s.'),
		htmlspecialchars($MOD['product'], ENT_COMPAT, 'ISO-8859-15'),
		'<a href="mailto:'.htmlspecialchars($cpoSystem['admin_email'], ENT_COMPAT, 'ISO-8859-15').'">',
		'</a>'
	);

	if ($_SESSION['SID_user']['admin']>=ROLE_SUPERUSER) {
		$message['license'] = '<strong>'.sprintf(___('Your 90 days %s evaluation period has expired!'), htmlspecialchars($MOD['product'], ENT_COMPAT, 'ISO-8859-15')).'</strong>';
		$message['license'] .= '<br />';
		$message['license'] .= sprintf(___('The %s-license model differs between commercial and non-commercial use.'), htmlspecialchars($MOD['product'], ENT_COMPAT, 'ISO-8859-15'));
		$message['license'] .= '<br />';
		$message['license'] .= sprintf(___('To use the system in commercial environments you need to purchase a "license for commercial use" in the moment of project release. This license can be ordered on the %s Website%s.'), '<a href="'.$MOD['productlink'].'" target="_blank">'.htmlspecialchars($MOD['product'], ENT_COMPAT, 'ISO-8859-15'), '</a>');
		$message['license'] .= '<br />';
		$message['license'] .= sprintf(___('If you are using %s non-commercially, you can register for free at this point in time on the %s Website%s.'), htmlspecialchars($MOD['product'], ENT_COMPAT, 'ISO-8859-15'), '<a href="'.$MOD['productlink'].'" target="_blank">'.htmlspecialchars($MOD['product'], ENT_COMPAT, 'ISO-8859-15'), '</a>');
	}
}

// Seitenausgabe ********************************************************
// Artikel
if (
	$_GET['action']  == "articles_modify" || 
	$_GET['action']  == "articles_copy" || 
	$_GET['action']  == "articles_delete" || 
	$_GET['action']  == "articles_versions" ||
	$_GET['action']  == "articles_copy" || 
	$_GET['action']  == "articles_delete" || 
	$_GET['action']  == "articles_versions_status" || 
	$_GET['action']  == "articles_status_versions" || 
	$_GET['action']  == "articles_status" || 
	$_GET['action']  == "articles_versions_restore" || 
	$_GET['action']  == "articles_versions_delete" || 
	$_POST['action'] == "articles_delete_really" ||
	$_POST['action'] == "articles_save" ||
	$_POST['action'] == "articles_status"
	)  {
        // alle nicht Newsletter-spezifischen Artikelbearbeitungsschritte
        include(CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/newsletter_articles.inc.php');
        exit;
        }


// Newsletter
// Header
require(CPO_BASEDIR.'_include/header.php');

if (isset($_GET['pos'])) $_SESSION['SID_pagers']['articles'] = $_GET['pos'];

if (isset($_POST['list'])) $_GET['list'] = $_POST['list'];

if ($_GET['action'] == 'modify'  ||  $_GET['action'] == 'create')  include(CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/inc_edit_receiver.inc.php');

if ($_POST['action'] == "articles_save") include(CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/inc_letters.inc.php');

if (isset($_GET['permission_id']) || isset($_GET['newsletter_user_id']))  include (CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/inc_rights.inc.php');

switch ($_GET['list'])  {
	case 'create':
		include(CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/create.inc.php');
		break;
	case 'compose':
	case 'saving':
		include(CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/compose.inc.php');
		break;
	case 'email':
		include(CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/inc_email.inc.php');
		break;
	case 'letters':
		include(CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/inc_letters.inc.php');
		break;
	case 'options':
		include (CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/inc_options.inc.php');
		break;
	case 'rights':
		include (CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/inc_rights.inc.php');
		break;
	case 'upload':
		include (CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/inc_file_browse.inc.php');
		break;
}

// ==== footer =====
if ($_GET['list'] != 'create') include(CPO_BASEDIR.'_include/footer.php');
?>