<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Newsletter"				                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

=== Version 4.3e / January 2014 ===

*/

define('CPO', true);
require_once('../_include/checkaccess.inc.php');

if (!isset($_REQUEST['action'])) $_REQUEST['action'] = '';


if (!empty($_SESSION['SID_log_login_id'])) {

    // user is logged in

    $_SESSION['SID_navigation_id'] = 0;
    if (isset($_GET['navigation'])) {
        $_t = explode(':', $_GET['navigation']);
        $_SESSION['SID_navigation_id'] = $_t[0];
        $_GET['rubric'] = $_t[1];
    }

    // change rubric if requested
    if (isset($_GET['rubric']) && $_GET['rubric']!=$_SESSION['SID_rubric_id']) {

        $query = "SELECT id, name, directory, seclevel, source_rubric_id "
                ."FROM ".CPO_RUBRIC." "
                ."WHERE id='".addslashes($_GET['rubric'])."'";
        if ($_GET['rubric']=='') {
            $query = "SELECT '' as id, '' as name, '' as directory, '' as seclevel, '' as source_rubric_id ";
        }
        DEBUG(4, $query, __FILE__, __LINE__);   
        $db = new DB;
        $db->query($query);
        $db->next_record();

        $_SESSION['SID_rubric_id']                  = $db->v('id');
        $_SESSION['SID_rubric_name']                = $db->v('name');
        $_SESSION['SID_rubric_secure']              = $db->v('seclevel');
        $_SESSION['SID_rubric_directory']           = $db->v('directory');
        $_SESSION['SID_rubric_source_rubric_id']    = $db->v('source_rubric_id');
        if ($_SESSION['SID_rubric_source_rubric_id']==0) // only use SID_rubric_source_rubric_id to fetch the data
            $_SESSION['SID_rubric_source_rubric_id'] = $_SESSION['SID_rubric_id'];

        $_SESSION['SID_pagers']['articles'] = 0;
    }

    require(CPO_BASEDIR.'_include/check.php');
} // if (!empty ($_SESSION['log_login_id'])) {

session_write_close(); // store session before loading frames 
CPOsession_start(); // to allow transparent session id support again
?>
<html>
<head>
    <title><?php echo $cpoTitle ?></title>
    <meta name="robots"       content="noindex,nofollow">
    <meta http-equiv="pragma" content="no-cache">
</head>

<?php if ($_GET['action'] == "create")  { ?>
<frameset rows="116,*" frameborder="0" border="0">
    <frame src="<?php echo BASE_URL.'_admin/frame_titel.php?action='.$_REQUEST['action']; ?>" name="cpo_titel" scrolling="no" marginwidth="0" noresize>
    <frameset cols="205,*">
        <?php if (!empty($_SESSION['SID_log_login_id'])) { ?>
            <frame name="cpo_navigation"    scrolling="auto" noresize src="<?php echo BASE_URL.'_admin/frame_navigation.php?'.SID; ?>" >
            <frame name="cpo_content" scrolling="auto" noresize src="<?php
                if ($_SESSION['SID_rubric_id']=='') echo htmlspecialchars(BASE_URL.'_admin/rubrics.php?first=1&'.SID, ENT_COMPAT, 'ISO-8859-15');
                else                                echo htmlspecialchars(BASE_URL.$activeModules[$directory]['directory'].'/newsletter.php?list=create&'.SID, ENT_COMPAT, 'ISO-8859-15');
            ?>">
        <?php } else { ?>
            <frame name="cpo_navigation" scrolling="auto" noresize src="<?php echo BASE_URL.'_admin/frame_navigation.php?'.SID; ?>">
            <frame name="cpo_content"    scrolling="auto" noresize src="<?php echo BASE_URL.'_admin/login.php?action='.htmlspecialchars($naction, ENT_COMPAT, 'ISO-8859-15').'&'.SID; ?>">
        <?php } ?>
    </frameset>
</frameset>
<?php } else if ($_GET['action'] == "compose")  { ?>
<frameset rows="116,*" frameborder="0" border="0">
    <frame src="<?php echo BASE_URL.'_admin/frame_titel.php?action='.$_REQUEST['action']; ?>" name="cpo_titel" scrolling="no" marginwidth="0" noresize>
    <frameset cols="205,*">
        <?php if (!empty($_SESSION['SID_log_login_id'])) { ?>
            <frame name="cpo_navigation"    scrolling="auto" noresize src="<?php echo BASE_URL.'_admin/frame_navigation.php?'.SID; ?>" >
            <frame name="cpo_content" scrolling="auto" noresize src="<?php
                if ($_SESSION['SID_rubric_id']=='') echo htmlspecialchars(BASE_URL.'_admin/rubrics.php?first=1&'.SID, ENT_COMPAT, 'ISO-8859-15');
                else                                echo htmlspecialchars(BASE_URL.$activeModules[$directory]['directory'].'/newsletter.php?list=compose&'.SID, ENT_COMPAT, 'ISO-8859-15');
            ?>">
        <?php } else { ?>
            <frame name="cpo_navigation" scrolling="auto" noresize src="<?php echo BASE_URL.'_admin/frame_navigation.php?'.SID; ?>">
            <frame name="cpo_content"    scrolling="auto" noresize src="<?php echo BASE_URL.'_admin/login.php?action='.htmlspecialchars($naction, ENT_COMPAT, 'ISO-8859-15').'&'.SID; ?>">
        <?php } ?>
    </frameset>
</frameset>
<?php } else { ?>
<frameset rows="116,*" frameborder="0" border="0">
    <frame src="<?php echo BASE_URL.'_admin/frame_titel.php?action='.$_REQUEST['action']; ?>" name="cpo_titel" scrolling="no" marginwidth="0" noresize>
    <frameset cols="205,*">
        <?php if (!empty($_SESSION['SID_log_login_id'])) { ?>
            <frame name="cpo_navigation"    scrolling="auto" noresize src="<?php echo BASE_URL.'_admin/frame_navigation.php?'.SID; ?>" >
            <frame name="cpo_content" scrolling="auto" noresize src="<?php
                if ($_SESSION['SID_rubric_id']=='') echo htmlspecialchars(BASE_URL.'_admin/rubrics.php?first=1&'.SID, ENT_COMPAT, 'ISO-8859-15');
                else                                echo htmlspecialchars(BASE_URL.$activeModules[$directory]['directory'].'/newsletter.php?list=letters&'.SID, ENT_COMPAT, 'ISO-8859-15');
            ?>">
        <?php } else { ?>
            <frame name="cpo_navigation" scrolling="auto" noresize src="<?php echo BASE_URL.'_admin/frame_navigation.php?'.SID; ?>">
            <frame name="cpo_content"    scrolling="auto" noresize src="<?php echo BASE_URL.'_admin/login.php?action='.htmlspecialchars($naction, ENT_COMPAT, 'ISO-8859-15').'&'.SID; ?>">
        <?php } ?>
    </frameset>
</frameset>
<?php }  ?>
</html>
